"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _settings = _interopRequireDefault(require("./settings"));

var _Container = _interopRequireDefault(require("./display/Container"));

var _autoRenderer = require("./autoRenderer");

var _ticker = require("./ticker");

var _const = require("./const");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var Application = /*#__PURE__*/function () {
  function Application(options, arg2, arg3, arg4, arg5) {
    _classCallCheck(this, Application);

    if (typeof options === "number") {
      options = Object.assign({
        width: options,
        height: arg2 || _settings["default"].RENDER_OPTIONS.height,
        forceCanvas: !!arg4,
        sharedTicker: !!arg5
      }, arg3);
    }

    this._options = options = Object.assign({
      autoStart: true,
      sharedTicker: false,
      forceCanvas: false,
      sharedLoader: false
    }, options);
    this.renderer = (0, _autoRenderer.autoRenderer)(options);
    this.stage = new _Container["default"]();
    this._ticker = null;
    this.ticker = options.sharedTicker ? _ticker.shared : new _ticker.Ticker();
    if (options.autoStart) this.start();
  }

  _createClass(Application, [{
    key: "ticker",
    get: function get() {
      return this._ticker;
    },
    set: function set(ticker) {
      if (this._ticker) this._ticker.remove(this.render, this);
      this._ticker = ticker;
      if (ticker) ticker.add(this.render, this, _const.UPDATE_PRIORITY.LOW);
    }
  }, {
    key: "render",
    value: function render() {
      this.renderer.render(this.stage);
    }
  }, {
    key: "stop",
    value: function stop() {
      this._ticker.stop();
    }
  }, {
    key: "start",
    value: function start() {
      this._ticker.start();
    }
  }, {
    key: "view",
    get: function get() {
      return this.renderer.view;
    }
  }, {
    key: "screen",
    get: function get() {
      return this.renderer.screen;
    }
  }, {
    key: "destroy",
    value: function destroy(removeView, stageOptions) {
      if (this._ticker) {
        var oldTicker = this._ticker;
        this.ticker = null;
        oldTicker.destroy();
      }

      this.stage.destroy(stageOptions);
      this.stage = null;
      this.renderer.destroy(removeView);
      this.renderer = null;
      this._options = null;
    }
  }]);

  return Application;
}();

exports["default"] = Application;
//# sourceMappingURL=Application.js.map