"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _utils = require("../utils");

var _DisplayObject2 = _interopRequireDefault(require("./DisplayObject"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Container = /*#__PURE__*/function (_DisplayObject) {
  _inherits(Container, _DisplayObject);

  var _super = _createSuper(Container);

  function Container() {
    var _this;

    _classCallCheck(this, Container);

    _this = _super.call(this);
    _this.children = [];
    return _this;
  }

  _createClass(Container, [{
    key: "onChildrenChange",
    value: function onChildrenChange() {
      /* empty */
    }
  }, {
    key: "addChild",
    value: function addChild(child) {
      var argumentsLength = arguments.length;

      if (argumentsLength > 1) {
        for (var i = 0; i < argumentsLength; i++) {
          this.addChild(arguments[i]);
        }
      } else {
        // if the child has a parent then lets remove it as PixiJS objects can only exist in one place
        if (child.parent) {
          child.parent.removeChild(child);
        }

        child.parent = this; // ensure child transform will be recalculated

        child.transform._parentID = -1;
        this.children.push(child); // ensure bounds will be recalculated

        this._boundsID++; // TODO - lets either do all callbacks or all events.. not both!

        this.onChildrenChange(this.children.length - 1);
        child.emit("added", this);
      }

      return child;
    }
  }, {
    key: "addChildAt",
    value: function addChildAt(child, index) {
      if (index < 0 || index > this.children.length) {
        throw new Error("".concat(child, "addChildAt: The index ").concat(index, " supplied is out of bounds ").concat(this.children.length));
      }

      if (child.parent) {
        child.parent.removeChild(child);
      }

      child.parent = this;
      child.transform._parentID = -1;
      this.children.splice(index, 0, child);
      this._boundsID++;
      this.onChildrenChange(index);
      child.emit("added", this);
      return child;
    }
  }, {
    key: "swapChildren",
    value: function swapChildren(child, child2) {
      if (child === child2) {
        return;
      }

      var index1 = this.getChildIndex(child);
      var index2 = this.getChildIndex(child2);
      this.children[index1] = child2;
      this.children[index2] = child;
      this.onChildrenChange(index1 < index2 ? index1 : index2);
    }
  }, {
    key: "getChildIndex",
    value: function getChildIndex(child) {
      var index = this.children.indexOf(child);

      if (index === -1) {
        throw new Error("The supplied DisplayObject must be a child of the caller");
      }

      return index;
    }
  }, {
    key: "setChildIndex",
    value: function setChildIndex(child, index) {
      if (index < 0 || index >= this.children.length) {
        throw new Error("The index ".concat(index, " supplied is out of bounds ").concat(this.children.length));
      }

      var currentIndex = this.getChildIndex(child);
      (0, _utils.removeItems)(this.children, currentIndex, 1); // remove from old position

      this.children.splice(index, 0, child); // add at new position

      this.onChildrenChange(index);
    }
  }, {
    key: "getChildAt",
    value: function getChildAt(index) {
      if (index < 0 || index >= this.children.length) {
        throw new Error("getChildAt: Index (".concat(index, ") does not exist."));
      }

      return this.children[index];
    }
  }, {
    key: "removeChild",
    value: function removeChild(child) {
      var argumentsLength = arguments.length;

      if (argumentsLength > 1) {
        for (var i = 0; i < argumentsLength; i++) {
          this.removeChild(arguments[i]);
        }
      } else {
        var index = this.children.indexOf(child);
        if (index === -1) return null;
        child.parent = null; // ensure child transform will be recalculated

        child.transform._parentID = -1;
        (0, _utils.removeItems)(this.children, index, 1);
        this._boundsID++;
        this.onChildrenChange(index);
        child.emit("removed", this);
      }

      return child;
    }
  }, {
    key: "removeChildAt",
    value: function removeChildAt(index) {
      var child = this.getChildAt(index); // ensure child transform will be recalculated..

      child.parent = null;
      child.transform._parentID = -1;
      (0, _utils.removeItems)(this.children, index, 1); // ensure bounds will be recalculated

      this._boundsID++; // TODO - lets either do all callbacks or all events.. not both!

      this.onChildrenChange(index);
      child.emit("removed", this);
      return child;
    }
  }, {
    key: "removeChildren",
    value: function removeChildren() {
      var beginIndex = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var endIndex = arguments.length > 1 ? arguments[1] : undefined;
      var begin = beginIndex;
      var end = typeof endIndex === "number" ? endIndex : this.children.length;
      var range = end - begin;
      var removed;

      if (range > 0 && range <= end) {
        removed = this.children.splice(begin, range);

        for (var i = 0; i < removed.length; ++i) {
          removed[i].parent = null;

          if (removed[i].transform) {
            removed[i].transform._parentID = -1;
          }
        }

        this._boundsID++;
        this.onChildrenChange(beginIndex);

        for (var _i = 0; _i < removed.length; ++_i) {
          removed[_i].emit("removed", this);
        }

        return removed;
      } else if (range === 0 && this.children.length === 0) {
        return [];
      }

      throw new RangeError("removeChildren: numeric values are outside the acceptable range.");
    }
  }, {
    key: "updateTransform",
    value: function updateTransform() {
      this._boundsID++;
      this.transform.updateTransform(this.parent.transform); // TODO: check render flags, how to process stuff here

      this.worldAlpha = this.alpha * this.parent.worldAlpha;

      for (var i = 0, j = this.children.length; i < j; ++i) {
        var child = this.children[i];

        if (child.visible) {
          child.updateTransform();
        }
      }
    }
  }, {
    key: "calculateBounds",
    value: function calculateBounds() {
      this._bounds.clear();

      this._calculateBounds();

      for (var i = 0; i < this.children.length; i++) {
        var child = this.children[i];

        if (!child.visible || !child.renderable) {
          continue;
        }

        child.calculateBounds(); // TODO: filter+mask, need to mask both somehow

        if (child._mask) {
          child._mask.calculateBounds();

          this._bounds.addBoundsMask(child._bounds, child._mask._bounds);
        } else if (child.filterArea) {
          this._bounds.addBoundsArea(child._bounds, child.filterArea);
        } else {
          this._bounds.addBounds(child._bounds);
        }
      }

      this._lastBoundsID = this._boundsID;
    }
  }, {
    key: "_calculateBounds",
    value: function _calculateBounds() {// FILL IN//
    }
  }, {
    key: "renderWebGL",
    value: function renderWebGL(renderer) {
      // if the object is not visible or the alpha is 0 then no need to render this element
      if (!this.visible || this.worldAlpha <= 0 || !this.renderable) {
        return;
      } // do a quick check to see if this element has a mask or a filter.


      if (this._mask || this.filters && this.filters.length) {
        this.renderAdvancedWebGL(renderer);
      } else {
        this._renderWebGL(renderer); // simple render children!


        for (var i = 0, j = this.children.length; i < j; ++i) {
          this.children[i].renderWebGL(renderer);
        }
      }
    }
  }, {
    key: "renderAdvancedWebGL",
    value: function renderAdvancedWebGL(renderer) {
      renderer.flush();
      var filters = this._filters;
      var mask = this._mask; // push filter first as we need to ensure the stencil buffer is correct for any masking

      if (filters) {
        if (!this._enabledFilters) {
          this._enabledFilters = [];
        }

        this._enabledFilters.length = 0;

        for (var i = 0; i < filters.length; i++) {
          if (filters[i].enabled) {
            this._enabledFilters.push(filters[i]);
          }
        }

        if (this._enabledFilters.length) {
          renderer.filterManager.pushFilter(this, this._enabledFilters);
        }
      }

      if (mask) {
        renderer.maskManager.pushMask(this, this._mask);
      } // add this object to the batch, only rendered if it has a texture.


      this._renderWebGL(renderer); // now loop through the children and make sure they get rendered


      for (var _i2 = 0, j = this.children.length; _i2 < j; _i2++) {
        this.children[_i2].renderWebGL(renderer);
      }

      renderer.flush();

      if (mask) {
        renderer.maskManager.popMask(this, this._mask);
      }

      if (filters && this._enabledFilters && this._enabledFilters.length) {
        renderer.filterManager.popFilter();
      }
    }
  }, {
    key: "_renderWebGL",
    value: function _renderWebGL(renderer) {// this is where content itself gets rendered...
    }
  }, {
    key: "_renderCanvas",
    value: function _renderCanvas(renderer) {// this is where content itself gets rendered...
    }
  }, {
    key: "renderCanvas",
    value: function renderCanvas(renderer) {
      // if not visible or the alpha is 0 then no need to render this
      if (!this.visible || this.worldAlpha <= 0 || !this.renderable) {
        return;
      }

      if (this._mask) {
        renderer.maskManager.pushMask(this._mask);
      }

      this._renderCanvas(renderer);

      for (var i = 0, j = this.children.length; i < j; ++i) {
        this.children[i].renderCanvas(renderer);
      }

      if (this._mask) {
        renderer.maskManager.popMask(renderer);
      }
    }
  }, {
    key: "destroy",
    value: function destroy(options) {
      _get(_getPrototypeOf(Container.prototype), "destroy", this).call(this);

      var destroyChildren = typeof options === "boolean" ? options : options && options.children;
      var oldChildren = this.removeChildren(0, this.children.length);

      if (destroyChildren) {
        for (var i = 0; i < oldChildren.length; ++i) {
          oldChildren[i].destroy(options);
        }
      }
    }
  }, {
    key: "width",
    get: function get() {
      return this.scale.x * this.getLocalBounds().width;
    },
    set: function set(value) {
      var width = this.getLocalBounds().width;

      if (width !== 0) {
        this.scale.x = value / width;
      } else {
        this.scale.x = 1;
      }

      this._width = value;
    }
  }, {
    key: "height",
    get: function get() {
      return this.scale.y * this.getLocalBounds().height;
    },
    set: function set(value) {
      var height = this.getLocalBounds().height;

      if (height !== 0) {
        this.scale.y = value / height;
      } else {
        this.scale.y = 1;
      }

      this._height = value;
    }
  }]);

  return Container;
}(_DisplayObject2["default"]); // performance increase to avoid using call.. (10x faster)


exports["default"] = Container;
Container.prototype.containerUpdateTransform = Container.prototype.updateTransform;
//# sourceMappingURL=Container.js.map