"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

var _const = require("../const");

var _settings = _interopRequireDefault(require("../settings"));

var _Transform = _interopRequireDefault(require("./Transform"));

var _Bounds = _interopRequireDefault(require("./Bounds"));

var _math = require("../math");

var _utils = require("../utils");

var _TransformStatic = _interopRequireDefault(require("./TransformStatic"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DisplayObject = /*#__PURE__*/function (_EventEmitter) {
  _inherits(DisplayObject, _EventEmitter);

  var _super = _createSuper(DisplayObject);

  function DisplayObject() {
    var _this;

    _classCallCheck(this, DisplayObject);

    _this = _super.call(this);
    var TransformClass = _settings["default"].TRANSFORM_MODE === _const.TRANSFORM_MODE.STATIC ? _TransformStatic["default"] : _Transform["default"];
    _this.tempDisplayObjectParent = null;
    _this.transform = new TransformClass();
    _this.alpha = 1;
    _this.visible = true;
    _this.renderable = true;
    _this.parent = null;
    _this.worldAlpha = 1;
    _this.filterArea = null;
    _this._filters = null;
    _this._enabledFilters = null;
    _this._bounds = new _Bounds["default"]();
    _this._boundsID = 0;
    _this._lastBoundsID = -1;
    _this._boundsRect = null;
    _this._localBoundsRect = null;
    _this._mask = null;
    _this._destroyed = false;
    _this.id = (0, _utils.uuidvx)();
    return _this;
  }

  _createClass(DisplayObject, [{
    key: "_tempDisplayObjectParent",
    get: function get() {
      if (this.tempDisplayObjectParent === null) {
        this.tempDisplayObjectParent = new DisplayObject();
      }

      return this.tempDisplayObjectParent;
    }
  }, {
    key: "updateTransform",
    value: function updateTransform() {
      this.transform.updateTransform(this.parent.transform);
      this.worldAlpha = this.alpha * this.parent.worldAlpha;
      this._bounds.updateID++;
    }
  }, {
    key: "_recursivePostUpdateTransform",
    value: function _recursivePostUpdateTransform() {
      if (this.parent) {
        this.parent._recursivePostUpdateTransform();

        this.transform.updateTransform(this.parent.transform);
      } else {
        this.transform.updateTransform(this._tempDisplayObjectParent.transform);
      }
    }
  }, {
    key: "getBounds",
    value: function getBounds(skipUpdate, rect) {
      if (!skipUpdate) {
        if (!this.parent) {
          this.parent = this._tempDisplayObjectParent;
          this.updateTransform();
          this.parent = null;
        } else {
          this._recursivePostUpdateTransform();

          this.updateTransform();
        }
      }

      if (this._boundsID !== this._lastBoundsID) {
        this.calculateBounds();
      }

      if (!rect) {
        if (!this._boundsRect) {
          this._boundsRect = new _math.Rectangle();
        }

        rect = this._boundsRect;
      }

      return this._bounds.getRectangle(rect);
    }
  }, {
    key: "getLocalBounds",
    value: function getLocalBounds(rect) {
      var transformRef = this.transform;
      var parentRef = this.parent;
      this.parent = null;
      this.transform = this._tempDisplayObjectParent.transform;

      if (!rect) {
        if (!this._localBoundsRect) {
          this._localBoundsRect = new _math.Rectangle();
        }

        rect = this._localBoundsRect;
      }

      var bounds = this.getBounds(false, rect);
      this.parent = parentRef;
      this.transform = transformRef;
      return bounds;
    }
  }, {
    key: "toGlobal",
    value: function toGlobal(position, point) {
      var skipUpdate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

      if (!skipUpdate) {
        this._recursivePostUpdateTransform();

        if (!this.parent) {
          this.parent = this._tempDisplayObjectParent;
          this.displayObjectUpdateTransform();
          this.parent = null;
        } else {
          this.displayObjectUpdateTransform();
        }
      }

      return this.worldTransform.apply(position, point);
    }
  }, {
    key: "getGlobalPosition",
    value: function getGlobalPosition(point) {
      var skipUpdate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      if (this.parent) {
        this.parent.toGlobal(this.position, point, skipUpdate);
      } else {
        point.x = this.position.x;
        point.y = this.position.y;
      }

      return point;
    }
  }, {
    key: "toLocal",
    value: function toLocal(position, from, point, skipUpdate) {
      if (from) {
        position = from.toGlobal(position, point, skipUpdate);
      }

      if (!skipUpdate) {
        this._recursivePostUpdateTransform();

        if (!this.parent) {
          this.parent = this._tempDisplayObjectParent;
          this.displayObjectUpdateTransform();
          this.parent = null;
        } else {
          this.displayObjectUpdateTransform();
        }
      }

      return this.worldTransform.applyInverse(position, point);
    }
  }, {
    key: "renderWebGL",
    value: function renderWebGL(renderer) {// OVERWRITE;
    }
  }, {
    key: "renderCanvas",
    value: function renderCanvas(renderer) {// OVERWRITE;
    }
  }, {
    key: "setParent",
    value: function setParent(container) {
      if (!container || !container.addChild) {
        throw new Error("setParent: Argument must be a Container");
      }

      container.addChild(this);
      return container;
    }
  }, {
    key: "setTransform",
    value: function setTransform() {
      var x = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var y = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      var scaleX = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 1;
      var scaleY = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;
      var rotation = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
      var skewX = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;
      var skewY = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 0;
      var pivotX = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : 0;
      var pivotY = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : 0;
      this.position.x = x;
      this.position.y = y;
      this.scale.x = !scaleX ? 1 : scaleX;
      this.scale.y = !scaleY ? 1 : scaleY;
      this.rotation = rotation;
      this.skew.x = skewX;
      this.skew.y = skewY;
      this.pivot.x = pivotX;
      this.pivot.y = pivotY;
      return this;
    }
  }, {
    key: "attr",
    value: function attr(attrs) {
      for (var key in attrs) {
        var val = attrs[key];

        switch (key) {
          case "scale":
            this.scale.x = val;
            this.scale.y = val;
            break;

          case "skew":
            this.skew.x = val;
            this.skew.y = val;
            break;

          case "rotate":
            this.rotation = val;
            break;

          default:
            this[key] = val;
        }
      }
    }
  }, {
    key: "getAttr",
    value: function getAttr(key) {
      var attr;

      switch (key) {
        case "scale":
          attr = this.scale.x;
          break;

        case "rotate":
          attr = this.rotation;
          break;

        default:
          attr = this[key];
      }

      return attr;
    }
  }, {
    key: "x",
    get: function get() {
      return this.position.x;
    },
    set: function set(value) {
      this.transform.position.x = value;
    }
  }, {
    key: "y",
    get: function get() {
      return this.position.y;
    },
    set: function set(value) {
      this.transform.position.y = value;
    }
  }, {
    key: "worldTransform",
    get: function get() {
      return this.transform.worldTransform;
    }
  }, {
    key: "localTransform",
    get: function get() {
      return this.transform.localTransform;
    }
  }, {
    key: "position",
    get: function get() {
      return this.transform.position;
    },
    set: function set(value) {
      this.transform.position.copy(value);
    }
  }, {
    key: "scale",
    get: function get() {
      return this.transform.scale;
    },
    set: function set(value) {
      this.transform.scale.copy(value);
    }
  }, {
    key: "pivot",
    get: function get() {
      return this.transform.pivot;
    },
    set: function set(value) {
      this.transform.pivot.copy(value);
    }
  }, {
    key: "skew",
    get: function get() {
      return this.transform.skew;
    },
    set: function set(value) {
      this.transform.skew.copy(value);
    }
  }, {
    key: "rotation",
    get: function get() {
      return this.transform.rotation;
    },
    set: function set(value) {
      this.transform.rotation = value;
    }
  }, {
    key: "worldVisible",
    get: function get() {
      var item = this;

      do {
        if (!item.visible) {
          return false;
        }

        item = item.parent;
      } while (item);

      return true;
    }
  }, {
    key: "mask",
    get: function get() {
      return this._mask;
    },
    set: function set(value) {
      if (this._mask) {
        this._mask.renderable = true;
        this._mask.isMask = false;
      }

      this._mask = value;

      if (this._mask) {
        this._mask.renderable = false;
        this._mask.isMask = true;
      }
    }
  }, {
    key: "filters",
    get: function get() {
      return this._filters && this._filters.slice();
    },
    set: function set(value) {
      this._filters = value && value.slice();
    }
  }, {
    key: "destroy",
    value: function destroy() {
      this.removeAllListeners();

      if (this.parent) {
        this.parent.removeChild(this);
      }

      this.transform = null;
      this.parent = null;
      this._bounds = null;
      this._currentBounds = null;
      this._mask = null;
      this.filterArea = null;
      this.interactive = false;
      this.interactiveChildren = false;
      this._destroyed = true;
    }
  }]);

  return DisplayObject;
}(_eventemitter["default"]); // performance increase to avoid using call.. (10x faster)


exports["default"] = DisplayObject;
DisplayObject.prototype.displayObjectUpdateTransform = DisplayObject.prototype.updateTransform;
//# sourceMappingURL=DisplayObject.js.map