"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _math = require("../math");

var _TransformBase2 = _interopRequireDefault(require("./TransformBase"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var TransformStatic = /*#__PURE__*/function (_TransformBase) {
  _inherits(TransformStatic, _TransformBase);

  var _super = _createSuper(TransformStatic);

  function TransformStatic() {
    var _this;

    _classCallCheck(this, TransformStatic);

    _this = _super.call(this);
    _this.position = new _math.ObservablePoint(_this.onChange, _assertThisInitialized(_this), 0, 0);
    _this.scale = new _math.ObservablePoint(_this.onChange, _assertThisInitialized(_this), 1, 1);
    _this.pivot = new _math.ObservablePoint(_this.onChange, _assertThisInitialized(_this), 0, 0);
    _this.skew = new _math.ObservablePoint(_this.updateSkew, _assertThisInitialized(_this), 0, 0);
    _this._rotation = 0;
    _this._cx = 1; // cos rotation + skewY;

    _this._sx = 0; // sin rotation + skewY;

    _this._cy = 0; // cos rotation + Math.PI/2 - skewX;

    _this._sy = 1; // sin rotation + Math.PI/2 - skewX;

    _this._localID = 0;
    _this._currentLocalID = 0;
    return _this;
  }

  _createClass(TransformStatic, [{
    key: "onChange",
    value: function onChange() {
      this._localID++;
    }
  }, {
    key: "updateSkew",
    value: function updateSkew() {
      this._cx = Math.cos(this._rotation + this.skew._y);
      this._sx = Math.sin(this._rotation + this.skew._y);
      this._cy = -Math.sin(this._rotation - this.skew._x); // cos, added PI/2

      this._sy = Math.cos(this._rotation - this.skew._x); // sin, added PI/2

      this._localID++;
    }
  }, {
    key: "updateLocalTransform",
    value: function updateLocalTransform() {
      var lt = this.localTransform;

      if (this._localID !== this._currentLocalID) {
        // get the matrix values of the displayobject based on its transform properties..
        lt.a = this._cx * this.scale._x;
        lt.b = this._sx * this.scale._x;
        lt.c = this._cy * this.scale._y;
        lt.d = this._sy * this.scale._y;
        lt.tx = this.position._x - (this.pivot._x * lt.a + this.pivot._y * lt.c);
        lt.ty = this.position._y - (this.pivot._x * lt.b + this.pivot._y * lt.d);
        this._currentLocalID = this._localID; // force an update..

        this._parentID = -1;
      }
    }
  }, {
    key: "updateTransform",
    value: function updateTransform(parentTransform) {
      var lt = this.localTransform;

      if (this._localID !== this._currentLocalID) {
        // get the matrix values of the displayobject based on its transform properties..
        lt.a = this._cx * this.scale._x;
        lt.b = this._sx * this.scale._x;
        lt.c = this._cy * this.scale._y;
        lt.d = this._sy * this.scale._y;
        lt.tx = this.position._x - (this.pivot._x * lt.a + this.pivot._y * lt.c);
        lt.ty = this.position._y - (this.pivot._x * lt.b + this.pivot._y * lt.d);
        this._currentLocalID = this._localID; // force an update..

        this._parentID = -1;
      }

      if (this._parentID !== parentTransform._worldID) {
        // concat the parent matrix with the objects transform.
        var pt = parentTransform.worldTransform;
        var wt = this.worldTransform;
        wt.a = lt.a * pt.a + lt.b * pt.c;
        wt.b = lt.a * pt.b + lt.b * pt.d;
        wt.c = lt.c * pt.a + lt.d * pt.c;
        wt.d = lt.c * pt.b + lt.d * pt.d;
        wt.tx = lt.tx * pt.a + lt.ty * pt.c + pt.tx;
        wt.ty = lt.tx * pt.b + lt.ty * pt.d + pt.ty;
        this._parentID = parentTransform._worldID; // update the id of the transform..

        this._worldID++;
      }
    }
  }, {
    key: "setFromMatrix",
    value: function setFromMatrix(matrix) {
      matrix.decompose(this);
      this._localID++;
    }
  }, {
    key: "rotation",
    get: function get() {
      return this._rotation;
    },
    set: function set(value) {
      if (this._rotation !== value) {
        this._rotation = value;
        this.updateSkew();
      }
    }
  }]);

  return TransformStatic;
}(_TransformBase2["default"]);

exports["default"] = TransformStatic;
//# sourceMappingURL=TransformStatic.js.map