"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var GraphicsData = /*#__PURE__*/function () {
  function GraphicsData(lineWidth, lineColor, lineAlpha, fillColor, fillAlpha, fill, nativeLines, shape, lineAlignment) {
    _classCallCheck(this, GraphicsData);

    this.lineWidth = lineWidth;
    this.lineAlignment = lineAlignment;
    this.nativeLines = nativeLines;
    this.lineColor = lineColor;
    /**
     * the alpha of the line to draw
     * @member {number}
     */

    this.lineAlpha = lineAlpha;
    /**
     * cached tint of the line to draw
     * @member {number}
     * @private
     */

    this._lineTint = lineColor;
    /**
     * the color of the fill
     * @member {number}
     */

    this.fillColor = fillColor;
    /**
     * the alpha of the fill
     * @member {number}
     */

    this.fillAlpha = fillAlpha;
    /**
     * cached tint of the fill
     * @member {number}
     * @private
     */

    this._fillTint = fillColor;
    /**
     * whether or not the shape is filled with a colour
     * @member {boolean}
     */

    this.fill = fill;
    this.holes = [];
    /**
     * The shape object to draw.
     * @member {PISI.Circle|PISI.Ellipse|PISI.Polygon|PISI.Rectangle|PISI.RoundedRectangle}
     */

    this.shape = shape;
    /**
     * The type of the shape, see the Const.Shapes file for all the existing types,
     * @member {number}
     */

    this.type = shape.type;
  }
  /**
   * Creates a new GraphicsData object with the same values as this one.
   *
   * @return {PISI.GraphicsData} Cloned GraphicsData object
   */


  _createClass(GraphicsData, [{
    key: "clone",
    value: function clone() {
      return new GraphicsData(this.lineWidth, this.lineColor, this.lineAlpha, this.fillColor, this.fillAlpha, this.fill, this.nativeLines, this.shape, this.lineAlignment);
    }
    /**
     * Adds a hole to the shape.
     *
     * @param {PISI.Rectangle|PISI.Circle} shape - The shape of the hole.
     */

  }, {
    key: "addHole",
    value: function addHole(shape) {
      this.holes.push(shape);
    }
    /**
     * Destroys the Graphics data.
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this.shape = null;
      this.holes = null;
    }
  }]);

  return GraphicsData;
}();

exports["default"] = GraphicsData;
//# sourceMappingURL=GraphicsData.js.map