"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _gl2 = _interopRequireDefault(require("gl"));

var _canvas = require("canvas");

var _poly2 = _interopRequireDefault(require("./poly"));

var _glfix = _interopRequireDefault(require("./glfix"));

var _utils = require("../utils");

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function set(target, property, value, receiver) { if (typeof Reflect !== "undefined" && Reflect.set) { set = Reflect.set; } else { set = function set(target, property, value, receiver) { var base = _superPropBase(target, property); var desc; if (base) { desc = Object.getOwnPropertyDescriptor(base, property); if (desc.set) { desc.set.call(receiver, value); return true; } else if (!desc.writable) { return false; } } desc = Object.getOwnPropertyDescriptor(receiver, property); if (desc) { if (!desc.writable) { return false; } desc.value = value; Object.defineProperty(receiver, property, desc); } else { _defineProperty(receiver, property, value); } return true; }; } return set(target, property, value, receiver); }

function _set(target, property, value, receiver, isStrict) { var s = set(target, property, value, receiver || target); if (!s && isStrict) { throw new Error('failed to set property'); } return value; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var PSCanvas = /*#__PURE__*/function (_poly) {
  _inherits(PSCanvas, _poly);

  var _super = _createSuper(PSCanvas);

  function PSCanvas(width, height, type) {
    var _this;

    _classCallCheck(this, PSCanvas);

    _this = _super.call(this, width, height, type);
    _this._event = new _eventemitter["default"]();
    _this._glResizeExt = null;
    _this._gl = null;
    _this._renderType = "2d";
    _this.useTypedArray = false;
    _this.isPSCanvas = true;
    _this.id = (0, _utils.uuidvx)();
    return _this;
  } // Get canvas context


  _createClass(PSCanvas, [{
    key: "getContext",
    value: function getContext(type, options) {
      this._renderType = type;

      if (type === "webgl") {
        if (this._gl) return this._gl;
        var width = this.width,
            height = this.height;
        var ctx = (0, _gl2["default"])(width, height, options);

        _glfix["default"].fixGetUniformLocation(ctx);

        _glfix["default"].fixTexImage2D(ctx);

        this._gl = ctx;
        this._glResizeExt = ctx.getExtension("STACKGL_resize_drawingbuffer");
        this._ctx = _get(_getPrototypeOf(PSCanvas.prototype), "getContext", this).call(this, "2d", options);
        return this._gl;
      }

      return _get(_getPrototypeOf(PSCanvas.prototype), "getContext", this).call(this, type, options);
    } // Canvas Reset width and height

  }, {
    key: "height",
    get: function get() {
      return _get(_getPrototypeOf(PSCanvas.prototype), "height", this);
    },
    set: function set(value) {
      if (this._glResizeExt) this._glResizeExt.resize(this.width, value);

      _set(_getPrototypeOf(PSCanvas.prototype), "height", value, this, true);
    }
  }, {
    key: "width",
    get: function get() {
      return _get(_getPrototypeOf(PSCanvas.prototype), "width", this);
    },
    set: function set(value) {
      if (this._glResizeExt) this._glResizeExt.resize(value, this.height);

      _set(_getPrototypeOf(PSCanvas.prototype), "width", value, this, true);
    }
  }, {
    key: "clientWidth",
    get: function get() {
      return _get(_getPrototypeOf(PSCanvas.prototype), "width", this);
    }
  }, {
    key: "clientHeight",
    get: function get() {
      return _get(_getPrototypeOf(PSCanvas.prototype), "height", this);
    } // add and remove event listener

  }, {
    key: "addEventListener",
    value: function addEventListener(type, listener) {
      return this._event.addListener(type, listener);
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener(type, listener) {
      if (listener) return this._event.removeListener(type, listener);
      return this._event.removeAllListeners(type);
    }
  }, {
    key: "_putImageData",
    value: function _putImageData() {
      var data;
      var width = this.width,
          height = this.height,
          _ctx = this._ctx,
          _gl = this._gl,
          useTypedArray = this.useTypedArray;
      var pixels = new Uint8Array(width * height * 4);

      _gl.readPixels(0, 0, width, height, _gl.RGBA, _gl.UNSIGNED_BYTE, pixels);

      if (useTypedArray) {
        data = (0, _canvas.createImageData)(new Uint8ClampedArray(pixels), width, height);
      } else {
        data = _ctx.getImageData(0, 0, width, height);

        this._fillImageData(data, pixels, width, height);
      }

      _ctx.putImageData(data, 0, 0);
    }
  }, {
    key: "_fillImageData",
    value: function _fillImageData(data, pixels, width, height) {
      for (var i = 0; i < height; i++) {
        for (var j = 0; j < width; j++) {
          var col = j;
          var row = height - i - 1;

          for (var k = 0; k < 4; k++) {
            var idx = 4 * (row * width + col) + k;
            var idx2 = 4 * (i * width + col) + k;
            data.data[idx] = pixels[idx2];
          }
        }
      }

      return data;
    } // Store buffer png jpg and other data

  }, {
    key: "toBuffer",
    value: function toBuffer() {
      var _get2;

      if (this._gl) this._putImageData();

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return (_get2 = _get(_getPrototypeOf(PSCanvas.prototype), "toBuffer", this)).call.apply(_get2, [this].concat(args));
    }
  }, {
    key: "toDataURL",
    value: function toDataURL() {
      var _get3;

      if (this._gl) this._putImageData();

      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return (_get3 = _get(_getPrototypeOf(PSCanvas.prototype), "toDataURL", this)).call.apply(_get3, [this].concat(args));
    }
  }, {
    key: "createPNGStream",
    value: function createPNGStream() {
      var _get4;

      if (this._gl) this._putImageData();

      for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      return (_get4 = _get(_getPrototypeOf(PSCanvas.prototype), "createPNGStream", this)).call.apply(_get4, [this].concat(args));
    }
  }, {
    key: "createJPEGStream",
    value: function createJPEGStream() {
      var _get5;

      if (this._gl) this._putImageData();

      for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      return (_get5 = _get(_getPrototypeOf(PSCanvas.prototype), "createJPEGStream", this)).call.apply(_get5, [this].concat(args));
    }
  }, {
    key: "createPDFStream",
    value: function createPDFStream() {
      var _get6;

      if (this._gl) this._putImageData();

      for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      return (_get6 = _get(_getPrototypeOf(PSCanvas.prototype), "createPDFStream", this)).call.apply(_get6, [this].concat(args));
    }
  }, {
    key: "destroy",
    value: function destroy() {
      //super.destroy();
      this._event.removeAllListeners();

      this._event = null;
      this._glResizeExt = null;
      this._gl = null;
    }
  }]);

  return PSCanvas;
}((0, _poly2["default"])(_canvas.Canvas));

exports["default"] = PSCanvas;
//# sourceMappingURL=Canvas.js.map