"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _utils = require("../utils");

var _math = require("../math");

var _const = require("../const");

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

var _Doc = _interopRequireDefault(require("../polyfill/Doc"));

var _settings = _interopRequireDefault(require("../settings"));

var _Container = _interopRequireDefault(require("../display/Container"));

var _RenderTexture = _interopRequireDefault(require("../textures/RenderTexture"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var tempMatrix = new _math.Matrix();

var SystemRenderer = /*#__PURE__*/function (_EventEmitter) {
  _inherits(SystemRenderer, _EventEmitter);

  var _super = _createSuper(SystemRenderer);

  function SystemRenderer(system, options, arg2, arg3) {
    var _this;

    _classCallCheck(this, SystemRenderer);

    _this = _super.call(this);

    if (typeof options === "number") {
      options = Object.assign({
        width: options,
        height: arg2 || _settings["default"].RENDER_OPTIONS.height
      }, arg3);
    } // Add the default render options


    options = Object.assign({}, _settings["default"].RENDER_OPTIONS, options);
    _this.options = options;
    _this.type = _const.RENDERER_TYPE.UNKNOWN;
    _this.screen = new _math.Rectangle(0, 0, options.width, options.height);
    _this.view = options.view || _Doc["default"].createElement("canvas");
    _this.resolution = options.resolution || _settings["default"].RESOLUTION;
    _this.transparent = options.transparent;
    _this.autoResize = options.autoResize || false;
    _this.blendModes = null;
    _this.preserveDrawingBuffer = options.preserveDrawingBuffer;
    _this.clearBeforeRender = options.clearBeforeRender;
    _this.roundPixels = options.roundPixels;
    _this._backgroundColor = 0x000000;
    _this._backgroundColorRgba = [0, 0, 0, 0];
    _this._backgroundColorString = "#000000";
    _this.backgroundColor = options.backgroundColor || _this._backgroundColor; // run bg color setter

    _this._tempDisplayObjectParent = new _Container["default"]();
    _this._lastObjectRendered = _this._tempDisplayObjectParent;
    return _this;
  }

  _createClass(SystemRenderer, [{
    key: "width",
    get: function get() {
      return this.view.width;
    }
  }, {
    key: "height",
    get: function get() {
      return this.view.height;
    }
  }, {
    key: "resize",
    value: function resize(screenWidth, screenHeight) {
      this.screen.width = screenWidth;
      this.screen.height = screenHeight;
      this.view.width = screenWidth * this.resolution;
      this.view.height = screenHeight * this.resolution;

      if (this.autoResize) {
        this.view.style.width = "".concat(screenWidth, "px");
        this.view.style.height = "".concat(screenHeight, "px");
      }
    }
  }, {
    key: "destroy",
    value: function destroy(removeView) {
      if (removeView && this.view.parentNode) {
        this.view.parentNode.removeChild(this.view);
      }

      this.type = _const.RENDERER_TYPE.UNKNOWN;
      this.view = null;
      this.screen = null;
      this.resolution = 0;
      this.transparent = false;
      this.autoResize = false;
      this.blendModes = null;
      this.options = null;
      this.preserveDrawingBuffer = false;
      this.clearBeforeRender = false;
      this.roundPixels = false;
      this._backgroundColor = 0;
      this._backgroundColorRgba = null;
      this._backgroundColorString = null;
      this._tempDisplayObjectParent = null;
      this._lastObjectRendered = null;
    }
  }, {
    key: "backgroundColor",
    get: function get() {
      return this._backgroundColor;
    },
    set: function set(value) {
      this._backgroundColor = value;
      this._backgroundColorString = (0, _utils.hex2string)(value);
      (0, _utils.hex2rgb)(value, this._backgroundColorRgba);
    }
  }]);

  return SystemRenderer;
}(_eventemitter["default"]);

exports["default"] = SystemRenderer;
//# sourceMappingURL=SystemRenderer.js.map