"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _SystemRenderer2 = _interopRequireDefault(require("../SystemRenderer"));

var _CanvasMaskManager = _interopRequireDefault(require("./utils/CanvasMaskManager"));

var _mapCanvasBlendModesToPixi = _interopRequireDefault(require("./utils/mapCanvasBlendModesToPixi"));

var _utils = require("../../utils");

var _const = require("../../const");

var _settings = _interopRequireDefault(require("../../settings"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var CanvasRenderer = /*#__PURE__*/function (_SystemRenderer) {
  _inherits(CanvasRenderer, _SystemRenderer);

  var _super = _createSuper(CanvasRenderer);

  function CanvasRenderer(options, arg2, arg3) {
    var _this;

    _classCallCheck(this, CanvasRenderer);

    _this = _super.call(this, "Canvas", options, arg2, arg3);
    _this.type = _const.RENDERER_TYPE.CANVAS;
    _this.rootContext = _this.view.getContext("2d", {
      alpha: _this.transparent
    });
    _this.context = _this.rootContext;
    _this.refresh = true;
    _this.maskManager = new _CanvasMaskManager["default"](_assertThisInitialized(_this));
    _this.smoothProperty = "imageSmoothingEnabled";

    if (!_this.rootContext.imageSmoothingEnabled) {
      if (_this.rootContext.webkitImageSmoothingEnabled) {
        _this.smoothProperty = "webkitImageSmoothingEnabled";
      } else if (_this.rootContext.mozImageSmoothingEnabled) {
        _this.smoothProperty = "mozImageSmoothingEnabled";
      } else if (_this.rootContext.oImageSmoothingEnabled) {
        _this.smoothProperty = "oImageSmoothingEnabled";
      } else if (_this.rootContext.msImageSmoothingEnabled) {
        _this.smoothProperty = "msImageSmoothingEnabled";
      }
    }

    _this.initPlugins();

    _this.blendModes = (0, _mapCanvasBlendModesToPixi["default"])();
    _this._activeBlendMode = null;
    _this.renderingToScreen = false;

    _this.resize(_this.options.width, _this.options.height);

    return _this;
  }

  _createClass(CanvasRenderer, [{
    key: "render",
    value: function render(displayObject, renderTexture, clear, transform, skipUpdateTransform) {
      if (!this.view) {
        return;
      } // can be handy to know!


      this.renderingToScreen = !renderTexture;
      this.emit("prerender");
      var rootResolution = this.resolution;
      this.context = this.rootContext;
      var context = this.context;

      if (!renderTexture) {
        this._lastObjectRendered = displayObject;
      }

      if (!skipUpdateTransform) {
        var cacheParent = displayObject.parent;
        var tempWt = this._tempDisplayObjectParent.transform.worldTransform;

        if (transform) {
          transform.copy(tempWt);
          this._tempDisplayObjectParent.transform._worldID = -1;
        } else {
          tempWt.identity();
        }

        displayObject.parent = this._tempDisplayObjectParent;
        displayObject.updateTransform();
        displayObject.parent = cacheParent; // displayObject.hitArea = //TODO add a temp hit area
      }

      context.save();
      context.setTransform(1, 0, 0, 1, 0, 0);
      context.globalAlpha = 1;
      this._activeBlendMode = _const.BLEND_MODES.NORMAL;
      context.globalCompositeOperation = this.blendModes[_const.BLEND_MODES.NORMAL];

      if (clear !== undefined ? clear : this.clearBeforeRender) {
        if (this.renderingToScreen) {
          if (this.transparent) {
            context.clearRect(0, 0, this.width, this.height);
          } else {
            context.fillStyle = this._backgroundColorString;
            context.fillRect(0, 0, this.width, this.height);
          }
        }
      } // TODO RENDER TARGET STUFF HERE..


      var tempContext = this.context;
      this.context = context;
      displayObject.renderCanvas(this);
      this.context = tempContext;
      context.restore();
      this.resolution = rootResolution;
      this.emit("postrender");
    }
    /**
     * Clear the canvas of renderer.
     *
     * @param {string} [clearColor] - Clear the canvas with this color, except the canvas is transparent.
     */

  }, {
    key: "clear",
    value: function clear(clearColor) {
      var context = this.context;
      clearColor = clearColor || this._backgroundColorString;

      if (!this.transparent && clearColor) {
        context.fillStyle = clearColor;
        context.fillRect(0, 0, this.width, this.height);
      } else {
        context.clearRect(0, 0, this.width, this.height);
      }
    }
    /**
     * Sets the blend mode of the renderer.
     *
     * @param {number} blendMode - See {@link PISI.BLEND_MODES} for valid values.
     */

  }, {
    key: "setBlendMode",
    value: function setBlendMode(blendMode) {
      if (this._activeBlendMode === blendMode) {
        return;
      }

      this._activeBlendMode = blendMode;
      this.context.globalCompositeOperation = this.blendModes[blendMode];
    }
  }, {
    key: "destroy",
    value: function destroy(removeView) {
      this.destroyPlugins(); // call the base destroy

      _get(_getPrototypeOf(CanvasRenderer.prototype), "destroy", this).call(this, removeView);

      this.context = null;
      this.refresh = true;
      this.maskManager.destroy();
      this.maskManager = null;
      this.smoothProperty = null;
    }
  }, {
    key: "resize",
    value: function resize(screenWidth, screenHeight) {
      _get(_getPrototypeOf(CanvasRenderer.prototype), "resize", this).call(this, screenWidth, screenHeight); // reset the scale mode.. oddly this seems to be reset when the canvas is resized.
      // surely a browser bug?? Let PixiJS fix that for you..


      if (this.smoothProperty) {
        this.rootContext[this.smoothProperty] = _settings["default"].SCALE_MODE === _const.SCALE_MODES.LINEAR;
      }
    }
    /**
     * Checks if blend mode has changed.
     */

  }, {
    key: "invalidateBlendMode",
    value: function invalidateBlendMode() {
      this._activeBlendMode = this.blendModes.indexOf(this.context.globalCompositeOperation);
    }
  }]);

  return CanvasRenderer;
}(_SystemRenderer2["default"]);

exports["default"] = CanvasRenderer;

_utils.pluginTarget.mixin(CanvasRenderer);
//# sourceMappingURL=CanvasRenderer.js.map