"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _SystemRenderer2 = _interopRequireDefault(require("../SystemRenderer"));

var _MaskManager = _interopRequireDefault(require("./managers/MaskManager"));

var _StencilManager = _interopRequireDefault(require("./managers/StencilManager"));

var _FilterManager = _interopRequireDefault(require("./managers/FilterManager"));

var _RenderTarget = _interopRequireDefault(require("./utils/RenderTarget"));

var _ObjectRenderer = _interopRequireDefault(require("./utils/ObjectRenderer"));

var _TextureManager = _interopRequireDefault(require("./TextureManager"));

var _BaseTexture = _interopRequireDefault(require("../../textures/BaseTexture"));

var _TextureGarbageCollector = _interopRequireDefault(require("./TextureGarbageCollector"));

var _WebGLState = _interopRequireDefault(require("./WebGLState"));

var _mapWebGLDrawModesToPixi = _interopRequireDefault(require("./utils/mapWebGLDrawModesToPixi"));

var _validateContext = _interopRequireDefault(require("./utils/validateContext"));

var _utils = require("../../utils");

var _pixiGlCore = _interopRequireDefault(require("pixi-gl-core"));

var _const = require("../../const");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var CONTEXT_UID = 0;

var WebGLRenderer = /*#__PURE__*/function (_SystemRenderer) {
  _inherits(WebGLRenderer, _SystemRenderer);

  var _super = _createSuper(WebGLRenderer);

  function WebGLRenderer(options, arg2, arg3) {
    var _this;

    _classCallCheck(this, WebGLRenderer);

    _this = _super.call(this, "WebGL", options, arg2, arg3);
    _this.legacy = _this.options.legacy;

    if (_this.legacy) {
      _pixiGlCore["default"].VertexArrayObject.FORCE_NATIVE = true;
    }

    _this.type = _const.RENDERER_TYPE.WEBGL;
    _this.handleContextLost = _this.handleContextLost.bind(_assertThisInitialized(_this));
    _this.handleContextRestored = _this.handleContextRestored.bind(_assertThisInitialized(_this));

    _this.view.addEventListener("webglcontextlost", _this.handleContextLost, false);

    _this.view.addEventListener("webglcontextrestored", _this.handleContextRestored, false);

    _this._contextOptions = {
      alpha: _this.transparent,
      antialias: _this.options.antialias,
      premultipliedAlpha: _this.transparent && _this.transparent !== "notMultiplied",
      stencil: true,
      preserveDrawingBuffer: _this.options.preserveDrawingBuffer,
      powerPreference: _this.options.powerPreference
    };
    _this._backgroundColorRgba[3] = _this.transparent ? 0 : 1;
    _this.maskManager = new _MaskManager["default"](_assertThisInitialized(_this));
    _this.stencilManager = new _StencilManager["default"](_assertThisInitialized(_this));
    _this.emptyRenderer = new _ObjectRenderer["default"](_assertThisInitialized(_this));
    _this.currentRenderer = _this.emptyRenderer;
    _this.textureManager = null;
    _this.filterManager = null;

    _this.initPlugins(); // initialize the context so it is ready for the managers.


    if (_this.options.context) {
      // checks to see if a context is valid..
      (0, _validateContext["default"])(_this.options.context);
    }

    _this.gl = _this.options.context || _pixiGlCore["default"].createContext(_this.view, _this._contextOptions);
    _this.CONTEXT_UID = CONTEXT_UID++;
    _this.state = new _WebGLState["default"](_this.gl);
    _this.renderingToScreen = true;
    _this.boundTextures = null;
    _this._activeShader = null;
    _this._activeVao = null;
    _this._activeRenderTarget = null;

    _this._initContext(); // map some webGL blend and drawmodes..


    _this.drawModes = (0, _mapWebGLDrawModesToPixi["default"])(_this.gl);
    _this._nextTextureLocation = 0;

    _this.setBlendMode(0);

    return _this;
  }

  _createClass(WebGLRenderer, [{
    key: "_initContext",
    value: function _initContext() {
      var gl = this.gl; // restore a context if it was previously lost

      if (gl.isContextLost() && gl.getExtension("WEBGL_lose_context")) {
        gl.getExtension("WEBGL_lose_context").restoreContext();
      }

      var maxTextures = gl.getParameter(gl.MAX_TEXTURE_IMAGE_UNITS);
      this._activeShader = null;
      this._activeVao = null;
      this.boundTextures = new Array(maxTextures);
      this.emptyTextures = new Array(maxTextures);
      this._unknownBoundTextures = false; // create a texture manager...

      this.textureManager = new _TextureManager["default"](this);
      this.filterManager = new _FilterManager["default"](this);
      this.textureGC = new _TextureGarbageCollector["default"](this);
      this.state.resetToDefault();
      this.rootRenderTarget = new _RenderTarget["default"](gl, this.width, this.height, null, this.resolution, true);
      this.rootRenderTarget.clearColor = this._backgroundColorRgba;
      this.bindRenderTarget(this.rootRenderTarget); // now lets fill up the textures with empty ones!

      var emptyGLTexture = new _pixiGlCore["default"].GLTexture.fromData(gl, null, 1, 1);
      var tempObj = {
        _glTextures: {}
      };
      tempObj._glTextures[this.CONTEXT_UID] = {};

      for (var i = 0; i < maxTextures; i++) {
        var empty = new _BaseTexture["default"]();
        empty._glTextures[this.CONTEXT_UID] = emptyGLTexture;
        this.boundTextures[i] = tempObj;
        this.emptyTextures[i] = empty;
        this.bindTexture(null, i);
      }

      this.emit("context", gl); // setup the width/height properties and gl viewport

      this.resize(this.screen.width, this.screen.height);
    }
  }, {
    key: "render",
    value: function render(displayObject, renderTexture, clear, transform, skipUpdateTransform) {
      this.renderingToScreen = !renderTexture;
      this.emit("prerender");

      if (!this.gl || this.gl.isContextLost()) {
        return;
      }

      this._nextTextureLocation = 0;

      if (!renderTexture) {
        this._lastObjectRendered = displayObject;
      }

      if (!skipUpdateTransform) {
        // update the scene graph
        var cacheParent = displayObject.parent;
        displayObject.parent = this._tempDisplayObjectParent;
        displayObject.updateTransform();
        displayObject.parent = cacheParent; // displayObject.hitArea = //TODO add a temp hit area
      }

      this.bindRenderTexture(renderTexture, transform);
      this.currentRenderer.start();

      if (clear !== undefined ? clear : this.clearBeforeRender) {
        this._activeRenderTarget.clear();
      }

      displayObject.renderWebGL(this);
      this.currentRenderer.flush();
      this.textureGC.update();
      this.emit("postrender");
    }
  }, {
    key: "setObjectRenderer",
    value: function setObjectRenderer(objectRenderer) {
      if (this.currentRenderer === objectRenderer) {
        return;
      }

      this.currentRenderer.stop();
      this.currentRenderer = objectRenderer;
      this.currentRenderer.start();
    }
  }, {
    key: "flush",
    value: function flush() {
      this.setObjectRenderer(this.emptyRenderer);
    }
  }, {
    key: "resize",
    value: function resize(screenWidth, screenHeight) {
      _SystemRenderer2["default"].prototype.resize.call(this, screenWidth, screenHeight);

      this.rootRenderTarget.resize(screenWidth, screenHeight);

      if (this._activeRenderTarget === this.rootRenderTarget) {
        this.rootRenderTarget.activate();

        if (this._activeShader) {
          this._activeShader.uniforms.projectionMatrix = this.rootRenderTarget.projectionMatrix.toArray(true);
        }
      }
    }
  }, {
    key: "setBlendMode",
    value: function setBlendMode(blendMode) {
      this.state.setBlendMode(blendMode);
    }
  }, {
    key: "deleteTexture",
    value: function deleteTexture(texture) {
      this.gl.deleteTexture(texture);
    }
  }, {
    key: "clear",
    value: function clear(clearColor) {
      this._activeRenderTarget.clear(clearColor);
    }
  }, {
    key: "setTransform",
    value: function setTransform(matrix) {
      this._activeRenderTarget.transform = matrix;
    }
  }, {
    key: "clearRenderTexture",
    value: function clearRenderTexture(renderTexture, clearColor) {
      var baseTexture = renderTexture.baseTexture;
      var renderTarget = baseTexture._glRenderTargets[this.CONTEXT_UID];

      if (renderTarget) {
        renderTarget.clear(clearColor);
      }

      return this;
    }
  }, {
    key: "bindRenderTexture",
    value: function bindRenderTexture(renderTexture, transform) {
      var renderTarget;

      if (renderTexture) {
        var baseTexture = renderTexture.baseTexture;

        if (!baseTexture._glRenderTargets[this.CONTEXT_UID]) {
          this.textureManager.updateTexture(baseTexture, 0);
        }

        this.unbindTexture(baseTexture);
        renderTarget = baseTexture._glRenderTargets[this.CONTEXT_UID];
        renderTarget.setFrame(renderTexture.frame);
      } else {
        renderTarget = this.rootRenderTarget;
      }

      renderTarget.transform = transform;
      this.bindRenderTarget(renderTarget);
      return this;
    }
  }, {
    key: "bindRenderTarget",
    value: function bindRenderTarget(renderTarget) {
      if (renderTarget !== this._activeRenderTarget) {
        this._activeRenderTarget = renderTarget;
        renderTarget.activate();

        if (this._activeShader) {
          this._activeShader.uniforms.projectionMatrix = renderTarget.projectionMatrix.toArray(true);
        }

        this.stencilManager.setMaskStack(renderTarget.stencilMaskStack);
      }

      return this;
    }
  }, {
    key: "bindShader",
    value: function bindShader(shader, autoProject) {
      // TODO cache
      if (this._activeShader !== shader) {
        this._activeShader = shader;
        shader.bind(); // `autoProject` normally would be a default parameter set to true
        // but because of how Babel transpiles default parameters
        // it hinders the performance of this method.

        if (autoProject !== false) {
          // automatically set the projection matrix
          shader.uniforms.projectionMatrix = this._activeRenderTarget.projectionMatrix.toArray(true);
        }
      }

      return this;
    }
  }, {
    key: "bindTexture",
    value: function bindTexture(texture, location, forceLocation) {
      texture = texture || this.emptyTextures[location];
      texture = texture.baseTexture || texture;
      texture.touched = this.textureGC.count;

      if (!forceLocation) {
        // TODO - maybe look into adding boundIds.. save us the loop?
        for (var i = 0; i < this.boundTextures.length; i++) {
          if (this.boundTextures[i] === texture) {
            return i;
          }
        }

        if (location === undefined) {
          this._nextTextureLocation++;
          this._nextTextureLocation %= this.boundTextures.length;
          location = this.boundTextures.length - this._nextTextureLocation - 1;
        }
      } else {
        location = location || 0;
      }

      var gl = this.gl;
      var glTexture = texture._glTextures[this.CONTEXT_UID];

      if (!glTexture) {
        // this will also bind the texture..
        this.textureManager.updateTexture(texture, location);
      } else {
        // bind the current texture
        this.boundTextures[location] = texture;
        gl.activeTexture(gl.TEXTURE0 + location);
        gl.bindTexture(gl.TEXTURE_2D, glTexture.texture);
      }

      return location;
    }
  }, {
    key: "unbindTexture",
    value: function unbindTexture(texture) {
      var gl = this.gl;
      texture = texture.baseTexture || texture;

      if (this._unknownBoundTextures) {
        this._unknownBoundTextures = false; // someone changed webGL state,
        // we have to be sure that our texture does not appear in multitexture renderer samplers

        for (var i = 0; i < this.boundTextures.length; i++) {
          if (this.boundTextures[i] === this.emptyTextures[i]) {
            gl.activeTexture(gl.TEXTURE0 + i);
            gl.bindTexture(gl.TEXTURE_2D, this.emptyTextures[i]._glTextures[this.CONTEXT_UID].texture);
          }
        }
      }

      for (var _i = 0; _i < this.boundTextures.length; _i++) {
        if (this.boundTextures[_i] === texture) {
          this.boundTextures[_i] = this.emptyTextures[_i];
          gl.activeTexture(gl.TEXTURE0 + _i);
          gl.bindTexture(gl.TEXTURE_2D, this.emptyTextures[_i]._glTextures[this.CONTEXT_UID].texture);
        }
      }

      return this;
    }
  }, {
    key: "createVao",
    value: function createVao() {
      return new _pixiGlCore["default"].VertexArrayObject(this.gl, this.state.attribState);
    }
  }, {
    key: "bindVao",
    value: function bindVao(vao) {
      if (this._activeVao === vao) {
        return this;
      }

      if (vao) {
        vao.bind();
      } else if (this._activeVao) {
        // TODO this should always be true i think?
        this._activeVao.unbind();
      }

      this._activeVao = vao;
      return this;
    }
  }, {
    key: "reset",
    value: function reset() {
      this.setObjectRenderer(this.emptyRenderer);
      this.bindVao(null);
      this._activeShader = null;
      this._activeRenderTarget = this.rootRenderTarget;
      this._unknownBoundTextures = true;

      for (var i = 0; i < this.boundTextures.length; i++) {
        this.boundTextures[i] = this.emptyTextures[i];
      } // bind the main frame buffer (the screen);


      this.rootRenderTarget.activate();
      this.state.resetToDefault();
      return this;
    }
  }, {
    key: "handleContextLost",
    value: function handleContextLost(event) {
      event.preventDefault();
    }
  }, {
    key: "handleContextRestored",
    value: function handleContextRestored() {
      this.textureManager.removeAll();
      this.filterManager.destroy(true);

      this._initContext();
    }
  }, {
    key: "destroy",
    value: function destroy(removeView) {
      this.destroyPlugins(); // remove listeners

      this.view.removeEventListener("webglcontextlost", this.handleContextLost);
      this.view.removeEventListener("webglcontextrestored", this.handleContextRestored);
      this.textureManager.destroy(); // call base destroy

      _get(_getPrototypeOf(WebGLRenderer.prototype), "destroy", this).call(this, removeView);

      this.uid = 0; // destroy the managers

      this.maskManager.destroy();
      this.stencilManager.destroy();
      this.filterManager.destroy();
      this.maskManager = null;
      this.filterManager = null;
      this.textureManager = null;
      this.currentRenderer = null;
      this.handleContextLost = null;
      this.handleContextRestored = null;
      this._contextOptions = null;
      this.gl.useProgram(null);

      if (this.gl.getExtension("WEBGL_lose_context")) {
        this.gl.getExtension("WEBGL_lose_context").loseContext();
      }

      this.gl = null; // this = null;
    }
  }]);

  return WebGLRenderer;
}(_SystemRenderer2["default"]);

exports["default"] = WebGLRenderer;

_utils.pluginTarget.mixin(WebGLRenderer);
//# sourceMappingURL=WebGLRenderer.js.map