"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _WebGLManager2 = _interopRequireDefault(require("./WebGLManager"));

var _SpriteMaskFilter = _interopRequireDefault(require("../filters/spriteMask/SpriteMaskFilter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var MaskManager = /*#__PURE__*/function (_WebGLManager) {
  _inherits(MaskManager, _WebGLManager);

  var _super = _createSuper(MaskManager);

  function MaskManager(renderer) {
    var _this;

    _classCallCheck(this, MaskManager);

    _this = _super.call(this, renderer);
    _this.scissor = false;
    _this.scissorData = null;
    _this.scissorRenderTarget = null;
    _this.enableScissor = true;
    _this.alphaMaskPool = [];
    _this.alphaMaskIndex = 0;
    return _this;
  }

  _createClass(MaskManager, [{
    key: "pushMask",
    value: function pushMask(target, maskData) {
      if (maskData.texture) {
        this.pushSpriteMask(target, maskData);
      } else if (this.enableScissor && !this.scissor && this.renderer._activeRenderTarget.root && !this.renderer.stencilManager.stencilMaskStack.length && maskData.isFastRect()) {
        var matrix = maskData.worldTransform;
        var rot = Math.atan2(matrix.b, matrix.a); // use the nearest degree!

        rot = Math.round(rot * (180 / Math.PI));

        if (rot % 90) {
          this.pushStencilMask(maskData);
        } else {
          this.pushScissorMask(target, maskData);
        }
      } else {
        this.pushStencilMask(maskData);
      }
    }
  }, {
    key: "popMask",
    value: function popMask(target, maskData) {
      if (maskData.texture) {
        this.popSpriteMask(target, maskData);
      } else if (this.enableScissor && !this.renderer.stencilManager.stencilMaskStack.length) {
        this.popScissorMask(target, maskData);
      } else {
        this.popStencilMask(target, maskData);
      }
    }
  }, {
    key: "pushSpriteMask",
    value: function pushSpriteMask(target, maskData) {
      var alphaMaskFilter = this.alphaMaskPool[this.alphaMaskIndex];

      if (!alphaMaskFilter) {
        alphaMaskFilter = this.alphaMaskPool[this.alphaMaskIndex] = [new _SpriteMaskFilter["default"](maskData)];
      }

      alphaMaskFilter[0].resolution = this.renderer.resolution;
      alphaMaskFilter[0].maskSprite = maskData;
      var stashFilterArea = target.filterArea;
      target.filterArea = maskData.getBounds(true);
      this.renderer.filterManager.pushFilter(target, alphaMaskFilter);
      target.filterArea = stashFilterArea;
      this.alphaMaskIndex++;
    }
  }, {
    key: "popSpriteMask",
    value: function popSpriteMask() {
      this.renderer.filterManager.popFilter();
      this.alphaMaskIndex--;
    }
  }, {
    key: "pushStencilMask",
    value: function pushStencilMask(maskData) {
      this.renderer.currentRenderer.stop();
      this.renderer.stencilManager.pushStencil(maskData);
    }
  }, {
    key: "popStencilMask",
    value: function popStencilMask() {
      this.renderer.currentRenderer.stop();
      this.renderer.stencilManager.popStencil();
    }
  }, {
    key: "pushScissorMask",
    value: function pushScissorMask(target, maskData) {
      maskData.renderable = true;
      var renderTarget = this.renderer._activeRenderTarget;
      var bounds = maskData.getBounds();
      bounds.fit(renderTarget.size);
      maskData.renderable = false;
      this.renderer.gl.enable(this.renderer.gl.SCISSOR_TEST);
      var resolution = this.renderer.resolution;
      this.renderer.gl.scissor(bounds.x * resolution, (renderTarget.root ? renderTarget.size.height - bounds.y - bounds.height : bounds.y) * resolution, bounds.width * resolution, bounds.height * resolution);
      this.scissorRenderTarget = renderTarget;
      this.scissorData = maskData;
      this.scissor = true;
    }
  }, {
    key: "popScissorMask",
    value: function popScissorMask() {
      this.scissorRenderTarget = null;
      this.scissorData = null;
      this.scissor = false; // must be scissor!

      var gl = this.renderer.gl;
      gl.disable(gl.SCISSOR_TEST);
    }
  }]);

  return MaskManager;
}(_WebGLManager2["default"]);

exports["default"] = MaskManager;
//# sourceMappingURL=MaskManager.js.map