"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _WebGLManager2 = _interopRequireDefault(require("./WebGLManager"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var StencilManager = /*#__PURE__*/function (_WebGLManager) {
  _inherits(StencilManager, _WebGLManager);

  var _super = _createSuper(StencilManager);

  function StencilManager(renderer) {
    var _this;

    _classCallCheck(this, StencilManager);

    _this = _super.call(this, renderer);
    _this.stencilMaskStack = null;
    return _this;
  }

  _createClass(StencilManager, [{
    key: "setMaskStack",
    value: function setMaskStack(stencilMaskStack) {
      this.stencilMaskStack = stencilMaskStack;
      var gl = this.renderer.gl;

      if (stencilMaskStack.length === 0) {
        gl.disable(gl.STENCIL_TEST);
      } else {
        gl.enable(gl.STENCIL_TEST);
      }
    }
  }, {
    key: "pushStencil",
    value: function pushStencil(graphics) {
      this.renderer.setObjectRenderer(this.renderer.plugins.graphics);

      this.renderer._activeRenderTarget.attachStencilBuffer();

      var gl = this.renderer.gl;
      var prevMaskCount = this.stencilMaskStack.length;

      if (prevMaskCount === 0) {
        gl.enable(gl.STENCIL_TEST);
      }

      this.stencilMaskStack.push(graphics); // Increment the reference stencil value where the new mask overlaps with the old ones.

      gl.colorMask(false, false, false, false);
      gl.stencilFunc(gl.EQUAL, prevMaskCount, this._getBitwiseMask());
      gl.stencilOp(gl.KEEP, gl.KEEP, gl.INCR);
      this.renderer.plugins.graphics.render(graphics);

      this._useCurrent();
    }
  }, {
    key: "popStencil",
    value: function popStencil() {
      this.renderer.setObjectRenderer(this.renderer.plugins.graphics);
      var gl = this.renderer.gl;
      var graphics = this.stencilMaskStack.pop();

      if (this.stencilMaskStack.length === 0) {
        // the stack is empty!
        gl.disable(gl.STENCIL_TEST);
        gl.clear(gl.STENCIL_BUFFER_BIT);
        gl.clearStencil(0);
      } else {
        // Decrement the reference stencil value where the popped mask overlaps with the other ones
        gl.colorMask(false, false, false, false);
        gl.stencilOp(gl.KEEP, gl.KEEP, gl.DECR);
        this.renderer.plugins.graphics.render(graphics);

        this._useCurrent();
      }
    }
  }, {
    key: "_useCurrent",
    value: function _useCurrent() {
      var gl = this.renderer.gl;
      gl.colorMask(true, true, true, true);
      gl.stencilFunc(gl.EQUAL, this.stencilMaskStack.length, this._getBitwiseMask());
      gl.stencilOp(gl.KEEP, gl.KEEP, gl.KEEP);
    }
  }, {
    key: "_getBitwiseMask",
    value: function _getBitwiseMask() {
      return (1 << this.stencilMaskStack.length) - 1;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      _WebGLManager2["default"].prototype.destroy.call(this);

      this.stencilMaskStack.stencilStack = null;
    }
  }]);

  return StencilManager;
}(_WebGLManager2["default"]);

exports["default"] = StencilManager;
//# sourceMappingURL=StencilManager.js.map