"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Sprite2 = _interopRequireDefault(require("./Sprite"));

var _ticker = require("../ticker");

var _Texture = _interopRequireDefault(require("../textures/Texture"));

var _const = require("../const");

var _Maths = _interopRequireDefault(require("../math/Maths"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var AnimatedSprite = /*#__PURE__*/function (_Sprite) {
  _inherits(AnimatedSprite, _Sprite);

  var _super = _createSuper(AnimatedSprite);

  function AnimatedSprite(textures, autoUpdate) {
    var _this;

    _classCallCheck(this, AnimatedSprite);

    _this = _super.call(this, textures[0] instanceof _Texture["default"] ? textures[0] : textures[0].texture);
    _this._textures = null;
    _this._durations = null;
    _this.textures = textures;
    _this._autoUpdate = autoUpdate !== false;
    _this.animationSpeed = 1;
    _this.loop = true;
    _this.updateAnchor = false;
    _this.onComplete = null;
    _this.onFrameChange = null;
    _this.onLoop = null;
    _this._currentTime = 0;
    _this.playing = false;
    return _this;
  }

  _createClass(AnimatedSprite, [{
    key: "stop",
    value: function stop() {
      if (!this.playing) {
        return;
      }

      this.playing = false;

      if (this._autoUpdate) {
        _ticker.shared.remove(this.update, this);
      }
    }
  }, {
    key: "play",
    value: function play() {
      if (this.playing) {
        return;
      }

      this.playing = true;

      if (this._autoUpdate) {
        _ticker.shared.add(this.update, this, _const.UPDATE_PRIORITY.HIGH);
      }
    }
  }, {
    key: "gotoAndStop",
    value: function gotoAndStop(frameNumber) {
      this.stop();
      var previousFrame = this.currentFrame;
      this._currentTime = frameNumber;

      if (previousFrame !== this.currentFrame) {
        this.updateTexture();
      }
    }
  }, {
    key: "gotoAndPlay",
    value: function gotoAndPlay(frameNumber) {
      var previousFrame = this.currentFrame;
      this._currentTime = frameNumber;

      if (previousFrame !== this.currentFrame) {
        this.updateTexture();
      }

      this.play();
    }
  }, {
    key: "update",
    value: function update(deltaTime) {
      var elapsed = this.animationSpeed * deltaTime;
      var previousFrame = this.currentFrame;

      if (this._durations !== null) {
        var lag = this._currentTime % 1 * this._durations[this.currentFrame];
        lag += elapsed / 60 * 1000;

        while (lag < 0) {
          this._currentTime--;
          lag += this._durations[this.currentFrame];
        }

        var sign = _Maths["default"].sign(this.animationSpeed * deltaTime);

        this._currentTime = Math.floor(this._currentTime);

        while (lag >= this._durations[this.currentFrame]) {
          lag -= this._durations[this.currentFrame] * sign;
          this._currentTime += sign;
        }

        this._currentTime += lag / this._durations[this.currentFrame];
      } else {
        this._currentTime += elapsed;
      }

      if (this._currentTime < 0 && !this.loop) {
        this.gotoAndStop(0);

        if (this.onComplete) {
          this.onComplete();
        }
      } else if (this._currentTime >= this._textures.length && !this.loop) {
        this.gotoAndStop(this._textures.length - 1);

        if (this.onComplete) {
          this.onComplete();
        }
      } else if (previousFrame !== this.currentFrame) {
        if (this.loop && this.onLoop) {
          if (this.animationSpeed > 0 && this.currentFrame < previousFrame) {
            this.onLoop();
          } else if (this.animationSpeed < 0 && this.currentFrame > previousFrame) {
            this.onLoop();
          }
        }

        this.updateTexture();
      }
    }
  }, {
    key: "updateTexture",
    value: function updateTexture() {
      this._texture = this._textures[this.currentFrame];
      this._textureID = -1;
      this.cachedTint = 0xffffff;

      if (this.updateAnchor) {
        this._anchor.copy(this._texture.defaultAnchor);
      }

      if (this.onFrameChange) {
        this.onFrameChange(this.currentFrame);
      }
    }
  }, {
    key: "destroy",
    value: function destroy(options) {
      this.stop();

      _get(_getPrototypeOf(AnimatedSprite.prototype), "destroy", this).call(this, options);
    }
  }, {
    key: "totalFrames",
    get: function get() {
      return this._textures.length;
    }
  }, {
    key: "textures",
    get: function get() {
      return this._textures;
    },
    set: function set(value) {
      if (value[0] instanceof _Texture["default"]) {
        this._textures = value;
        this._durations = null;
      } else {
        this._textures = [];
        this._durations = [];

        for (var i = 0; i < value.length; i++) {
          this._textures.push(value[i].texture);

          this._durations.push(value[i].time);
        }
      }

      this.gotoAndStop(0);
      this.updateTexture();
    }
  }, {
    key: "currentFrame",
    get: function get() {
      var currentFrame = Math.floor(this._currentTime) % this._textures.length;

      if (currentFrame < 0) {
        currentFrame += this._textures.length;
      }

      return currentFrame;
    }
  }], [{
    key: "fromFrames",
    value: function fromFrames(frames) {
      var textures = [];

      for (var i = 0; i < frames.length; ++i) {
        textures.push(_Texture["default"].fromFrame(frames[i]));
      }

      return new AnimatedSprite(textures);
    }
  }, {
    key: "fromImages",
    value: function fromImages(images) {
      var textures = [];

      for (var i = 0; i < images.length; ++i) {
        textures.push(_Texture["default"].fromImage(images[i]));
      }

      return new AnimatedSprite(textures);
    }
  }]);

  return AnimatedSprite;
}(_Sprite2["default"]);

exports["default"] = AnimatedSprite;
//# sourceMappingURL=AnimatedSprite.js.map