"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _math = require("../math");

var _utils = require("../utils");

var _const = require("../const");

var _Texture = _interopRequireDefault(require("../textures/Texture"));

var _Container2 = _interopRequireDefault(require("../display/Container"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var tempPoint = new _math.Point();

var Sprite = /*#__PURE__*/function (_Container) {
  _inherits(Sprite, _Container);

  var _super = _createSuper(Sprite);

  function Sprite(texture) {
    var _this;

    _classCallCheck(this, Sprite);

    _this = _super.call(this);
    _this._anchor = new _math.ObservablePoint(_this._onAnchorUpdate, _assertThisInitialized(_this), texture ? texture.defaultAnchor.x : 0, texture ? texture.defaultAnchor.y : 0);
    _this._texture = null;
    _this._width = 0;
    _this._height = 0;
    _this._tint = null;
    _this._tintRGB = null;
    _this.tint = 0xffffff;
    _this.blendMode = _const.BLEND_MODES.NORMAL;
    _this.shader = null;
    _this.cachedTint = 0xffffff;
    _this.texture = texture || _Texture["default"].EMPTY;
    _this.vertexData = new Float32Array(8);
    _this.vertexTrimmedData = null;
    _this._transformID = -1;
    _this._textureID = -1;
    _this._transformTrimmedID = -1;
    _this._textureTrimmedID = -1;
    _this.pluginName = "sprite";
    return _this;
  }

  _createClass(Sprite, [{
    key: "_onTextureUpdate",
    value: function _onTextureUpdate() {
      this._textureID = -1;
      this._textureTrimmedID = -1;
      this.cachedTint = 0xffffff;

      if (this._width) {
        this.scale.x = (0, _utils.sign)(this.scale.x) * this._width / this._texture.orig.width;
      }

      if (this._height) {
        this.scale.y = (0, _utils.sign)(this.scale.y) * this._height / this._texture.orig.height;
      }
    }
  }, {
    key: "_onAnchorUpdate",
    value: function _onAnchorUpdate() {
      this._transformID = -1;
      this._transformTrimmedID = -1;
    }
  }, {
    key: "calculateVertices",
    value: function calculateVertices() {
      if (this._transformID === this.transform._worldID && this._textureID === this._texture._updateID) {
        return;
      }

      this._transformID = this.transform._worldID;
      this._textureID = this._texture._updateID;
      var texture = this._texture;
      var wt = this.transform.worldTransform;
      var a = wt.a;
      var b = wt.b;
      var c = wt.c;
      var d = wt.d;
      var tx = wt.tx;
      var ty = wt.ty;
      var vertexData = this.vertexData;
      var trim = texture.trim;
      var orig = texture.orig;
      var anchor = this._anchor;
      var w0 = 0;
      var w1 = 0;
      var h0 = 0;
      var h1 = 0;

      if (trim) {
        w1 = trim.x - anchor._x * orig.width;
        w0 = w1 + trim.width;
        h1 = trim.y - anchor._y * orig.height;
        h0 = h1 + trim.height;
      } else {
        w1 = -anchor._x * orig.width;
        w0 = w1 + orig.width;
        h1 = -anchor._y * orig.height;
        h0 = h1 + orig.height;
      } // xy


      vertexData[0] = a * w1 + c * h1 + tx;
      vertexData[1] = d * h1 + b * w1 + ty; // xy

      vertexData[2] = a * w0 + c * h1 + tx;
      vertexData[3] = d * h1 + b * w0 + ty; // xy

      vertexData[4] = a * w0 + c * h0 + tx;
      vertexData[5] = d * h0 + b * w0 + ty; // xy

      vertexData[6] = a * w1 + c * h0 + tx;
      vertexData[7] = d * h0 + b * w1 + ty;
    }
  }, {
    key: "calculateTrimmedVertices",
    value: function calculateTrimmedVertices() {
      if (!this.vertexTrimmedData) {
        this.vertexTrimmedData = new Float32Array(8);
      } else if (this._transformTrimmedID === this.transform._worldID && this._textureTrimmedID === this._texture._updateID) {
        return;
      }

      this._transformTrimmedID = this.transform._worldID;
      this._textureTrimmedID = this._texture._updateID; // lets do some special trim code!

      var texture = this._texture;
      var vertexData = this.vertexTrimmedData;
      var orig = texture.orig;
      var anchor = this._anchor; // lets calculate the new untrimmed bounds..

      var wt = this.transform.worldTransform;
      var a = wt.a;
      var b = wt.b;
      var c = wt.c;
      var d = wt.d;
      var tx = wt.tx;
      var ty = wt.ty;
      var w1 = -anchor._x * orig.width;
      var w0 = w1 + orig.width;
      var h1 = -anchor._y * orig.height;
      var h0 = h1 + orig.height; // xy

      vertexData[0] = a * w1 + c * h1 + tx;
      vertexData[1] = d * h1 + b * w1 + ty; // xy

      vertexData[2] = a * w0 + c * h1 + tx;
      vertexData[3] = d * h1 + b * w0 + ty; // xy

      vertexData[4] = a * w0 + c * h0 + tx;
      vertexData[5] = d * h0 + b * w0 + ty; // xy

      vertexData[6] = a * w1 + c * h0 + tx;
      vertexData[7] = d * h0 + b * w1 + ty;
    }
  }, {
    key: "_renderWebGL",
    value: function _renderWebGL(renderer) {
      this.calculateVertices();
      renderer.setObjectRenderer(renderer.plugins[this.pluginName]);
      renderer.plugins[this.pluginName].render(this);
    }
  }, {
    key: "_renderCanvas",
    value: function _renderCanvas(renderer) {
      renderer.plugins[this.pluginName].render(this);
    }
  }, {
    key: "_calculateBounds",
    value: function _calculateBounds() {
      var trim = this._texture.trim;
      var orig = this._texture.orig;

      if (!trim || trim.width === orig.width && trim.height === orig.height) {
        this.calculateVertices();

        this._bounds.addQuad(this.vertexData);
      } else {
        this.calculateTrimmedVertices();

        this._bounds.addQuad(this.vertexTrimmedData);
      }
    }
  }, {
    key: "getLocalBounds",
    value: function getLocalBounds(rect) {
      // we can do a fast local bounds if the sprite has no children!
      if (this.children.length === 0) {
        this._bounds.minX = this._texture.orig.width * -this._anchor._x;
        this._bounds.minY = this._texture.orig.height * -this._anchor._y;
        this._bounds.maxX = this._texture.orig.width * (1 - this._anchor._x);
        this._bounds.maxY = this._texture.orig.height * (1 - this._anchor._y);

        if (!rect) {
          if (!this._localBoundsRect) {
            this._localBoundsRect = new _math.Rectangle();
          }

          rect = this._localBoundsRect;
        }

        return this._bounds.getRectangle(rect);
      }

      return _get(_getPrototypeOf(Sprite.prototype), "getLocalBounds", this).call(this, rect);
    }
  }, {
    key: "containsPoint",
    value: function containsPoint(point) {
      this.worldTransform.applyInverse(point, tempPoint);
      var width = this._texture.orig.width;
      var height = this._texture.orig.height;
      var x1 = -width * this.anchor.x;
      var y1 = 0;

      if (tempPoint.x >= x1 && tempPoint.x < x1 + width) {
        y1 = -height * this.anchor.y;

        if (tempPoint.y >= y1 && tempPoint.y < y1 + height) {
          return true;
        }
      }

      return false;
    }
  }, {
    key: "destroy",
    value: function destroy(options) {
      _get(_getPrototypeOf(Sprite.prototype), "destroy", this).call(this, options);

      this._texture.off("update", this._onTextureUpdate, this);

      this._anchor = null;
      var destroyTexture = typeof options === "boolean" ? options : options && options.texture;

      if (destroyTexture) {
        var destroyBaseTexture = typeof options === "boolean" ? options : options && options.baseTexture;

        this._texture.destroy(!!destroyBaseTexture);
      }

      this._texture = null;
      this.shader = null;
    }
  }, {
    key: "width",
    get: function get() {
      return Math.abs(this.scale.x) * this._texture.orig.width;
    },
    set: function set(value) {
      var s = (0, _utils.sign)(this.scale.x) || 1;
      this.scale.x = s * value / this._texture.orig.width;
      this._width = value;
    }
  }, {
    key: "height",
    get: function get() {
      return Math.abs(this.scale.y) * this._texture.orig.height;
    },
    set: function set(value) {
      var s = (0, _utils.sign)(this.scale.y) || 1;
      this.scale.y = s * value / this._texture.orig.height;
      this._height = value;
    }
  }, {
    key: "anchor",
    get: function get() {
      return this._anchor;
    },
    set: function set(value) {
      this._anchor.copy(value);
    }
  }, {
    key: "tint",
    get: function get() {
      return this._tint;
    },
    set: function set(value) {
      this._tint = value;
      this._tintRGB = (value >> 16) + (value & 0xff00) + ((value & 0xff) << 16);
    }
  }, {
    key: "texture",
    get: function get() {
      return this._texture;
    },
    set: function set(value) {
      if (this._texture === value) {
        return;
      }

      this._texture = value || _Texture["default"].EMPTY;
      this.cachedTint = 0xffffff;
      this._textureID = -1;
      this._textureTrimmedID = -1;

      if (value) {
        if (value.baseTexture.hasLoaded) {
          this._onTextureUpdate();
        } else {
          value.once("update", this._onTextureUpdate, this);
        }
      }
    }
  }], [{
    key: "from",
    value: function from(source) {
      return new Sprite(_Texture["default"].from(source));
    }
  }, {
    key: "fromFrame",
    value: function fromFrame(frameId) {
      var texture = _utils.TextureCache[frameId];
      if (!texture) throw new Error("The frameId \"".concat(frameId, "\" does not exist"));
      return new Sprite(texture);
    }
  }, {
    key: "fromImage",
    value: function fromImage(imageId, crossorigin, scaleMode) {
      return new Sprite(_Texture["default"].fromImage(imageId, crossorigin, scaleMode));
    }
  }]);

  return Sprite;
}(_Container2["default"]);

exports["default"] = Sprite;
//# sourceMappingURL=Sprite.js.map