"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ObjectRenderer2 = _interopRequireDefault(require("../../renderers/webgl/utils/ObjectRenderer"));

var _WebGLRenderer = _interopRequireDefault(require("../../renderers/webgl/WebGLRenderer"));

var _createIndicesForQuads = _interopRequireDefault(require("../../utils/createIndicesForQuads"));

var _generateMultiTextureShader = _interopRequireDefault(require("./generateMultiTextureShader"));

var _checkMaxIfStatmentsInShader = _interopRequireDefault(require("../../renderers/webgl/utils/checkMaxIfStatmentsInShader"));

var _BatchBuffer = _interopRequireDefault(require("./BatchBuffer"));

var _settings = _interopRequireDefault(require("../../settings"));

var _utils = require("../../utils");

var _pixiGlCore = _interopRequireDefault(require("pixi-gl-core"));

var _bitTwiddle = _interopRequireDefault(require("bit-twiddle"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var TICK = 0;
var TEXTURE_TICK = 0;

var SpriteRenderer = /*#__PURE__*/function (_ObjectRenderer) {
  _inherits(SpriteRenderer, _ObjectRenderer);

  var _super = _createSuper(SpriteRenderer);

  function SpriteRenderer(renderer) {
    var _this;

    _classCallCheck(this, SpriteRenderer);

    _this = _super.call(this, renderer);
    _this.vertSize = 5;
    _this.vertByteSize = _this.vertSize * 4;
    _this.size = _settings["default"].SPRITE_BATCH_SIZE; // 2000 is a nice balance between mobile / desktop
    // the total number of bytes in our batch
    // let numVerts = this.size * 4 * this.vertByteSize;

    _this.buffers = [];

    for (var i = 1; i <= _bitTwiddle["default"].nextPow2(_this.size); i *= 2) {
      _this.buffers.push(new _BatchBuffer["default"](i * 4 * _this.vertByteSize));
    }
    /**
     * Holds the indices of the geometry (quads) to draw
     *
     * @member {Uint16Array}
     */


    _this.indices = (0, _createIndicesForQuads["default"])(_this.size);
    /**
     * The default shaders that is used if a sprite doesn't have a more specific one.
     * there is a shader for each number of textures that can be rendererd.
     * These shaders will also be generated on the fly as required.
     * @member {PISI.Shader[]}
     */

    _this.shader = null;
    _this.currentIndex = 0;
    _this.groups = [];

    for (var k = 0; k < _this.size; k++) {
      _this.groups[k] = {
        textures: [],
        textureCount: 0,
        ids: [],
        size: 0,
        start: 0,
        blend: 0
      };
    }

    _this.sprites = [];
    _this.vertexBuffers = [];
    _this.vaos = [];
    _this.vaoMax = 2;
    _this.vertexCount = 0;

    _this.renderer.on("prerender", _this.onPrerender, _assertThisInitialized(_this));

    return _this;
  }
  /**
   * Sets up the renderer context and necessary buffers.
   *
   * @private
   */


  _createClass(SpriteRenderer, [{
    key: "onContextChange",
    value: function onContextChange() {
      var gl = this.renderer.gl;

      if (this.renderer.legacy) {
        this.MAX_TEXTURES = 1;
      } else {
        // step 1: first check max textures the GPU can handle.
        this.MAX_TEXTURES = Math.min(gl.getParameter(gl.MAX_TEXTURE_IMAGE_UNITS), _settings["default"].SPRITE_MAX_TEXTURES); // step 2: check the maximum number of if statements the shader can have too..

        this.MAX_TEXTURES = (0, _checkMaxIfStatmentsInShader["default"])(this.MAX_TEXTURES, gl);
      }

      this.shader = (0, _generateMultiTextureShader["default"])(gl, this.MAX_TEXTURES); // create a couple of buffers

      this.indexBuffer = _pixiGlCore["default"].GLBuffer.createIndexBuffer(gl, this.indices, gl.STATIC_DRAW); // we use the second shader as the first one depending on your browser may omit aTextureId
      // as it is not used by the shader so is optimized out.

      this.renderer.bindVao(null);
      var attrs = this.shader.attributes;

      for (var i = 0; i < this.vaoMax; i++) {
        /* eslint-disable max-len */
        var vertexBuffer = this.vertexBuffers[i] = _pixiGlCore["default"].GLBuffer.createVertexBuffer(gl, null, gl.STREAM_DRAW);
        /* eslint-enable max-len */
        // build the vao object that will render..


        var vao = this.renderer.createVao().addIndex(this.indexBuffer).addAttribute(vertexBuffer, attrs.aVertexPosition, gl.FLOAT, false, this.vertByteSize, 0).addAttribute(vertexBuffer, attrs.aTextureCoord, gl.UNSIGNED_SHORT, true, this.vertByteSize, 2 * 4).addAttribute(vertexBuffer, attrs.aColor, gl.UNSIGNED_BYTE, true, this.vertByteSize, 3 * 4);

        if (attrs.aTextureId) {
          vao.addAttribute(vertexBuffer, attrs.aTextureId, gl.FLOAT, false, this.vertByteSize, 4 * 4);
        }

        this.vaos[i] = vao;
      }

      this.vao = this.vaos[0];
      this.currentBlendMode = 99999;
      this.boundTextures = new Array(this.MAX_TEXTURES);
    }
    /**
     * Called before the renderer starts rendering.
     *
     */

  }, {
    key: "onPrerender",
    value: function onPrerender() {
      this.vertexCount = 0;
    }
    /**
     * Renders the sprite object.
     *
     * @param {PISI.Sprite} sprite - the sprite to render when using this spritebatch
     */

  }, {
    key: "render",
    value: function render(sprite) {
      // TODO set blend modes..
      // check texture..
      if (this.currentIndex >= this.size) {
        this.flush();
      } // get the uvs for the texture
      // if the uvs have not updated then no point rendering just yet!


      if (!sprite._texture._uvs) {
        return;
      } // push a texture.
      // increment the batchsize


      this.sprites[this.currentIndex++] = sprite;
    }
    /**
     * Renders the content and empties the current batch.
     *
     */

  }, {
    key: "flush",
    value: function flush() {
      if (this.currentIndex === 0) {
        return;
      }

      var gl = this.renderer.gl;
      var MAX_TEXTURES = this.MAX_TEXTURES;

      var np2 = _bitTwiddle["default"].nextPow2(this.currentIndex);

      var log2 = _bitTwiddle["default"].log2(np2);

      var buffer = this.buffers[log2];
      var sprites = this.sprites;
      var groups = this.groups;
      var float32View = buffer.float32View;
      var uint32View = buffer.uint32View;
      var boundTextures = this.boundTextures;
      var rendererBoundTextures = this.renderer.boundTextures;
      var touch = this.renderer.textureGC.count;
      var index = 0;
      var nextTexture;
      var currentTexture;
      var groupCount = 1;
      var textureCount = 0;
      var currentGroup = groups[0];
      var vertexData;
      var uvs;
      var blendMode = _utils.premultiplyBlendMode[sprites[0]._texture.baseTexture.premultipliedAlpha ? 1 : 0][sprites[0].blendMode];
      currentGroup.textureCount = 0;
      currentGroup.start = 0;
      currentGroup.blend = blendMode;
      TICK++;
      var i; // copy textures..

      for (i = 0; i < MAX_TEXTURES; ++i) {
        var bt = rendererBoundTextures[i];

        if (bt._enabled === TICK) {
          boundTextures[i] = this.renderer.emptyTextures[i];
          continue;
        }

        boundTextures[i] = bt;
        bt._virtalBoundId = i;
        bt._enabled = TICK;
      }

      TICK++;

      for (i = 0; i < this.currentIndex; ++i) {
        // upload the sprite elemetns...
        // they have all ready been calculated so we just need to push them into the buffer.
        var sprite = sprites[i];
        sprites[i] = null;
        nextTexture = sprite._texture.baseTexture;

        var spriteBlendMode = _utils.premultiplyBlendMode[Number(nextTexture.premultipliedAlpha)][sprite.blendMode];

        if (blendMode !== spriteBlendMode) {
          // finish a group..
          blendMode = spriteBlendMode; // force the batch to break!

          currentTexture = null;
          textureCount = MAX_TEXTURES;
          TICK++;
        }

        if (currentTexture !== nextTexture) {
          currentTexture = nextTexture;

          if (nextTexture._enabled !== TICK) {
            if (textureCount === MAX_TEXTURES) {
              TICK++;
              currentGroup.size = i - currentGroup.start;
              textureCount = 0;
              currentGroup = groups[groupCount++];
              currentGroup.blend = blendMode;
              currentGroup.textureCount = 0;
              currentGroup.start = i;
            }

            nextTexture.touched = touch;

            if (nextTexture._virtalBoundId === -1) {
              for (var j = 0; j < MAX_TEXTURES; ++j) {
                var tIndex = (j + TEXTURE_TICK) % MAX_TEXTURES;
                var t = boundTextures[tIndex];

                if (t._enabled !== TICK) {
                  TEXTURE_TICK++;
                  t._virtalBoundId = -1;
                  nextTexture._virtalBoundId = tIndex;
                  boundTextures[tIndex] = nextTexture;
                  break;
                }
              }
            }

            nextTexture._enabled = TICK;
            currentGroup.textureCount++;
            currentGroup.ids[textureCount] = nextTexture._virtalBoundId;
            currentGroup.textures[textureCount++] = nextTexture;
          }
        }

        vertexData = sprite.vertexData; // TODO this sum does not need to be set each frame..

        uvs = sprite._texture._uvs.uvsUint32;

        if (this.renderer.roundPixels) {
          var resolution = this.renderer.resolution; // xy

          float32View[index] = (vertexData[0] * resolution | 0) / resolution;
          float32View[index + 1] = (vertexData[1] * resolution | 0) / resolution; // xy

          float32View[index + 5] = (vertexData[2] * resolution | 0) / resolution;
          float32View[index + 6] = (vertexData[3] * resolution | 0) / resolution; // xy

          float32View[index + 10] = (vertexData[4] * resolution | 0) / resolution;
          float32View[index + 11] = (vertexData[5] * resolution | 0) / resolution; // xy

          float32View[index + 15] = (vertexData[6] * resolution | 0) / resolution;
          float32View[index + 16] = (vertexData[7] * resolution | 0) / resolution;
        } else {
          // xy
          float32View[index] = vertexData[0];
          float32View[index + 1] = vertexData[1]; // xy

          float32View[index + 5] = vertexData[2];
          float32View[index + 6] = vertexData[3]; // xy

          float32View[index + 10] = vertexData[4];
          float32View[index + 11] = vertexData[5]; // xy

          float32View[index + 15] = vertexData[6];
          float32View[index + 16] = vertexData[7];
        }

        uint32View[index + 2] = uvs[0];
        uint32View[index + 7] = uvs[1];
        uint32View[index + 12] = uvs[2];
        uint32View[index + 17] = uvs[3];
        /* eslint-disable max-len */

        var alpha = Math.min(sprite.worldAlpha, 1.0); // we dont call extra function if alpha is 1.0, that's faster

        var argb = alpha < 1.0 && nextTexture.premultipliedAlpha ? (0, _utils.premultiplyTint)(sprite._tintRGB, alpha) : sprite._tintRGB + (alpha * 255 << 24);
        uint32View[index + 3] = uint32View[index + 8] = uint32View[index + 13] = uint32View[index + 18] = argb;
        float32View[index + 4] = float32View[index + 9] = float32View[index + 14] = float32View[index + 19] = nextTexture._virtalBoundId;
        /* eslint-enable max-len */

        index += 20;
      }

      currentGroup.size = i - currentGroup.start;

      if (!_settings["default"].CAN_UPLOAD_SAME_BUFFER) {
        // this is still needed for IOS performance..
        // it really does not like uploading to the same buffer in a single frame!
        if (this.vaoMax <= this.vertexCount) {
          this.vaoMax++;
          var attrs = this.shader.attributes;
          /* eslint-disable max-len */

          var vertexBuffer = this.vertexBuffers[this.vertexCount] = _pixiGlCore["default"].GLBuffer.createVertexBuffer(gl, null, gl.STREAM_DRAW);
          /* eslint-enable max-len */
          // build the vao object that will render..


          var vao = this.renderer.createVao().addIndex(this.indexBuffer).addAttribute(vertexBuffer, attrs.aVertexPosition, gl.FLOAT, false, this.vertByteSize, 0).addAttribute(vertexBuffer, attrs.aTextureCoord, gl.UNSIGNED_SHORT, true, this.vertByteSize, 2 * 4).addAttribute(vertexBuffer, attrs.aColor, gl.UNSIGNED_BYTE, true, this.vertByteSize, 3 * 4);

          if (attrs.aTextureId) {
            vao.addAttribute(vertexBuffer, attrs.aTextureId, gl.FLOAT, false, this.vertByteSize, 4 * 4);
          }

          this.vaos[this.vertexCount] = vao;
        }

        this.renderer.bindVao(this.vaos[this.vertexCount]);
        this.vertexBuffers[this.vertexCount].upload(buffer.vertices, 0, false);
        this.vertexCount++;
      } else {
        // lets use the faster option, always use buffer number 0
        this.vertexBuffers[this.vertexCount].upload(buffer.vertices, 0, true);
      }

      for (i = 0; i < MAX_TEXTURES; ++i) {
        rendererBoundTextures[i]._virtalBoundId = -1;
      } // render the groups..


      for (i = 0; i < groupCount; ++i) {
        var group = groups[i];
        var groupTextureCount = group.textureCount;

        for (var _j = 0; _j < groupTextureCount; _j++) {
          currentTexture = group.textures[_j]; // reset virtual ids..
          // lets do a quick check..

          if (rendererBoundTextures[group.ids[_j]] !== currentTexture) {
            this.renderer.bindTexture(currentTexture, group.ids[_j], true);
          } // reset the virtualId..


          currentTexture._virtalBoundId = -1;
        } // set the blend mode..


        this.renderer.state.setBlendMode(group.blend);
        gl.drawElements(gl.TRIANGLES, group.size * 6, gl.UNSIGNED_SHORT, group.start * 6 * 2);
      } // reset elements for the next flush


      this.currentIndex = 0;
    }
    /**
     * Starts a new sprite batch.
     */

  }, {
    key: "start",
    value: function start() {
      this.renderer.bindShader(this.shader);

      if (_settings["default"].CAN_UPLOAD_SAME_BUFFER) {
        // bind buffer #0, we don't need others
        this.renderer.bindVao(this.vaos[this.vertexCount]);
        this.vertexBuffers[this.vertexCount].bind();
      }
    }
    /**
     * Stops and flushes the current batch.
     *
     */

  }, {
    key: "stop",
    value: function stop() {
      this.flush();
    }
    /**
     * Destroys the SpriteRenderer.
     *
     */

  }, {
    key: "destroy",
    value: function destroy() {
      for (var i = 0; i < this.vaoMax; i++) {
        if (this.vertexBuffers[i]) {
          this.vertexBuffers[i].destroy();
        }

        if (this.vaos[i]) {
          this.vaos[i].destroy();
        }
      }

      if (this.indexBuffer) {
        this.indexBuffer.destroy();
      }

      this.renderer.off("prerender", this.onPrerender, this);

      _get(_getPrototypeOf(SpriteRenderer.prototype), "destroy", this).call(this);

      if (this.shader) {
        this.shader.destroy();
        this.shader = null;
      }

      this.vertexBuffers = null;
      this.vaos = null;
      this.indexBuffer = null;
      this.indices = null;
      this.sprites = null;

      for (var _i = 0; _i < this.buffers.length; ++_i) {
        this.buffers[_i].destroy();
      }
    }
  }]);

  return SpriteRenderer;
}(_ObjectRenderer2["default"]);

exports["default"] = SpriteRenderer;

_WebGLRenderer["default"].registerPlugin("sprite", SpriteRenderer);
//# sourceMappingURL=SpriteRenderer.js.map