"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Sprite2 = _interopRequireDefault(require("../sprites/Sprite"));

var _Texture = _interopRequireDefault(require("../textures/Texture"));

var _utils = require("../utils");

var _math = require("../math");

var _const = require("../const");

var _settings = _interopRequireDefault(require("../settings"));

var _TextStyle = _interopRequireDefault(require("./TextStyle"));

var _TextMetrics = _interopRequireDefault(require("./TextMetrics"));

var _trimCanvas = _interopRequireDefault(require("../utils/trimCanvas"));

var _Doc = _interopRequireDefault(require("../polyfill/Doc"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var defaultDestroyOptions = {
  texture: true,
  children: false,
  baseTexture: true
};

var Text = /*#__PURE__*/function (_Sprite) {
  _inherits(Text, _Sprite);

  var _super = _createSuper(Text);

  function Text(text, style, canvas) {
    var _this;

    _classCallCheck(this, Text);

    canvas = canvas || _Doc["default"].createElement("canvas");
    canvas.width = 3;
    canvas.height = 3;

    var texture = _Texture["default"].fromCanvas(canvas, _settings["default"].SCALE_MODE, "text");

    texture.orig = new _math.Rectangle();
    texture.trim = new _math.Rectangle();
    _this = _super.call(this, texture);

    _Texture["default"].addToCache(_this._texture, _this._texture.baseTexture.textureCacheIds[0]);

    _this.canvas = canvas;
    _this.context = _this.canvas.getContext("2d");
    _this.resolution = _settings["default"].RESOLUTION;
    _this._text = null;
    _this._style = null;
    _this._styleListener = null;
    _this._font = "";
    _this.text = text;
    _this.style = style;
    _this.localStyleID = -1;
    return _this;
  }

  _createClass(Text, [{
    key: "updateText",
    value: function updateText(respectDirty) {
      var style = this._style;

      if (this.localStyleID !== style.styleID) {
        this.dirty = true;
        this.localStyleID = style.styleID;
      }

      if (!this.dirty && respectDirty) {
        return;
      }

      this._font = this._style.toFontString();
      var context = this.context;

      var measured = _TextMetrics["default"].measureText(this._text, this._style, this._style.wordWrap, this.canvas);

      var width = measured.width;
      var height = measured.height;
      var lines = measured.lines;
      var lineHeight = measured.lineHeight;
      var lineWidths = measured.lineWidths;
      var maxLineWidth = measured.maxLineWidth;
      var fontProperties = measured.fontProperties;
      this.canvas.width = Math.ceil((Math.max(1, width) + style.padding * 2) * this.resolution);
      this.canvas.height = Math.ceil((Math.max(1, height) + style.padding * 2) * this.resolution);
      context.scale(this.resolution, this.resolution);
      context.clearRect(0, 0, this.canvas.width, this.canvas.height);
      this.drawBackground(style);
      context.font = this._font;
      context.strokeStyle = style.stroke;
      context.lineWidth = style.strokeThickness;
      context.textBaseline = style.textBaseline;
      context.lineJoin = style.lineJoin;
      context.miterLimit = style.miterLimit;
      var linePositionX;
      var linePositionY;

      if (style.dropShadow) {
        context.fillStyle = style.dropShadowColor;
        context.globalAlpha = style.dropShadowAlpha;
        context.shadowBlur = style.dropShadowBlur;

        if (style.dropShadowBlur > 0) {
          context.shadowColor = style.dropShadowColor;
        }

        var xShadowOffset = Math.cos(style.dropShadowAngle) * style.dropShadowDistance;
        var yShadowOffset = Math.sin(style.dropShadowAngle) * style.dropShadowDistance;

        for (var i = 0; i < lines.length; i++) {
          linePositionX = style.strokeThickness / 2;
          linePositionY = style.strokeThickness / 2 + i * lineHeight + fontProperties.ascent;

          if (style.align === "right") {
            linePositionX += maxLineWidth - lineWidths[i];
          } else if (style.align === "center") {
            linePositionX += (maxLineWidth - lineWidths[i]) / 2;
          }

          if (style.fill) {
            this.drawLetterSpacing(lines[i], linePositionX + xShadowOffset + style.padding, linePositionY + yShadowOffset + style.padding);

            if (style.stroke && style.strokeThickness) {
              context.strokeStyle = style.dropShadowColor;
              this.drawLetterSpacing(lines[i], linePositionX + xShadowOffset + style.padding, linePositionY + yShadowOffset + style.padding, true);
              context.strokeStyle = style.stroke;
            }
          }
        }
      }

      context.shadowBlur = 0;
      context.globalAlpha = 1;
      context.fillStyle = this._generateFillStyle(style, lines); // draw lines line by line

      for (var _i = 0; _i < lines.length; _i++) {
        linePositionX = style.strokeThickness / 2;
        linePositionY = style.strokeThickness / 2 + _i * lineHeight + fontProperties.ascent;

        if (style.align === "right") {
          linePositionX += maxLineWidth - lineWidths[_i];
        } else if (style.align === "center") {
          linePositionX += (maxLineWidth - lineWidths[_i]) / 2;
        }

        if (style.stroke && style.strokeThickness) {
          this.drawLetterSpacing(lines[_i], linePositionX + style.padding, linePositionY + style.padding, true);
        }

        if (style.fill) {
          this.drawLetterSpacing(lines[_i], linePositionX + style.padding, linePositionY + style.padding);
        }
      }

      this.updateTexture();
    }
  }, {
    key: "drawBackground",
    value: function drawBackground(style) {
      var background = style.background || style.backgroundColor;
      if (!background) return;
      var context = this.context;
      context.fillStyle = background;
      context.fillRect(0, 0, this.canvas.width, this.canvas.height);
    }
  }, {
    key: "drawLetterSpacing",
    value: function drawLetterSpacing(text, x, y) {
      var isStroke = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
      var style = this._style; // letterSpacing of 0 means normal

      var letterSpacing = style.letterSpacing;

      if (letterSpacing === 0) {
        if (isStroke) {
          this.context.strokeText(text, x, y);
        } else {
          this.context.fillText(text, x, y);
        }

        return;
      }

      var characters = String.prototype.split.call(text, "");
      var currentPosition = x;
      var index = 0;
      var current = "";
      var previousWidth = this.context.measureText(text).width;
      var currentWidth = 0;

      while (index < text.length) {
        current = characters[index++];

        if (isStroke) {
          this.context.strokeText(current, currentPosition, y);
        } else {
          this.context.fillText(current, currentPosition, y);
        }

        currentWidth = this.context.measureText(text.substring(index)).width;
        currentPosition += previousWidth - currentWidth + letterSpacing;
        previousWidth = currentWidth;
      }
    }
  }, {
    key: "updateStyle",
    value: function updateStyle(style) {
      for (var key in style) {
        var newKey = this.camelCase(key);
        if (newKey === "color") newKey = "fill";
        this.style[newKey] = style[key];
      }
    }
  }, {
    key: "camelCase",
    value: function camelCase(name) {
      var SPECIAL_CHARS_REGEXP = /([\:\-\_]+(.))/g;
      var MOZ_HACK_REGEXP = /^moz([A-Z])/;
      return name.replace(SPECIAL_CHARS_REGEXP, function (_, separator, letter, offset) {
        return offset ? letter.toUpperCase() : letter;
      }).replace(MOZ_HACK_REGEXP, "Moz$1");
    }
  }, {
    key: "updateTexture",
    value: function updateTexture() {
      var canvas = this.canvas;

      if (this._style.trim) {
        var trimmed = (0, _trimCanvas["default"])(canvas);

        if (trimmed.data) {
          canvas.width = trimmed.width;
          canvas.height = trimmed.height;
          this.context.putImageData(trimmed.data, 0, 0);
        }
      }

      var texture = this._texture;
      var style = this._style;
      var padding = style.trim ? 0 : style.padding;
      var baseTexture = texture.baseTexture;
      baseTexture.hasLoaded = true;
      baseTexture.resolution = this.resolution;
      baseTexture.realWidth = canvas.width;
      baseTexture.realHeight = canvas.height;
      baseTexture.width = canvas.width / this.resolution;
      baseTexture.height = canvas.height / this.resolution;
      texture.trim.width = texture._frame.width = canvas.width / this.resolution;
      texture.trim.height = texture._frame.height = canvas.height / this.resolution;
      texture.trim.x = -padding;
      texture.trim.y = -padding;
      texture.orig.width = texture._frame.width - padding * 2;
      texture.orig.height = texture._frame.height - padding * 2; // call sprite onTextureUpdate to update scale if _width or _height were set

      this._onTextureUpdate();

      baseTexture.emit("update", baseTexture);
      this.dirty = false;
    }
  }, {
    key: "renderWebGL",
    value: function renderWebGL(renderer) {
      if (this.resolution !== renderer.resolution) {
        this.resolution = renderer.resolution;
        this.dirty = true;
      }

      this.updateText(true);

      _get(_getPrototypeOf(Text.prototype), "renderWebGL", this).call(this, renderer);
    }
  }, {
    key: "_renderCanvas",
    value: function _renderCanvas(renderer) {
      if (this.resolution !== renderer.resolution) {
        this.resolution = renderer.resolution;
        this.dirty = true;
      }

      this.updateText(true);

      _get(_getPrototypeOf(Text.prototype), "_renderCanvas", this).call(this, renderer);
    }
  }, {
    key: "getLocalBounds",
    value: function getLocalBounds(rect) {
      this.updateText(true);
      return _get(_getPrototypeOf(Text.prototype), "getLocalBounds", this).call(this, rect);
    }
  }, {
    key: "_calculateBounds",
    value: function _calculateBounds() {
      this.updateText(true);
      this.calculateVertices(); // if we have already done this on THIS frame.

      this._bounds.addQuad(this.vertexData);
    }
  }, {
    key: "_onStyleChange",
    value: function _onStyleChange() {
      this.dirty = true;
    }
  }, {
    key: "_generateFillStyle",
    value: function _generateFillStyle(style, lines) {
      if (!Array.isArray(style.fill)) {
        return style.fill;
      }

      var gradient;
      var totalIterations;
      var currentIteration;
      var stop;
      var width = this.canvas.width / this.resolution;
      var height = this.canvas.height / this.resolution;
      var fill = style.fill.slice();
      var fillGradientStops = style.fillGradientStops.slice();

      if (!fillGradientStops.length) {
        var lengthPlus1 = fill.length + 1;

        for (var i = 1; i < lengthPlus1; ++i) {
          fillGradientStops.push(i / lengthPlus1);
        }
      }

      fill.unshift(style.fill[0]);
      fillGradientStops.unshift(0);
      fill.push(style.fill[style.fill.length - 1]);
      fillGradientStops.push(1);

      if (style.fillGradientType === _const.TEXT_GRADIENT.LINEAR_VERTICAL) {
        gradient = this.context.createLinearGradient(width / 2, 0, width / 2, height);
        totalIterations = (fill.length + 1) * lines.length;
        currentIteration = 0;

        for (var _i2 = 0; _i2 < lines.length; _i2++) {
          currentIteration += 1;

          for (var j = 0; j < fill.length; j++) {
            if (typeof fillGradientStops[j] === "number") {
              stop = fillGradientStops[j] / lines.length + _i2 / lines.length;
            } else {
              stop = currentIteration / totalIterations;
            }

            gradient.addColorStop(stop, fill[j]);
            currentIteration++;
          }
        }
      } else {
        gradient = this.context.createLinearGradient(0, height / 2, width, height / 2);
        totalIterations = fill.length + 1;
        currentIteration = 1;

        for (var _i3 = 0; _i3 < fill.length; _i3++) {
          if (typeof fillGradientStops[_i3] === "number") {
            stop = fillGradientStops[_i3];
          } else {
            stop = currentIteration / totalIterations;
          }

          gradient.addColorStop(stop, fill[_i3]);
          currentIteration++;
        }
      }

      return gradient;
    }
  }, {
    key: "destroy",
    value: function destroy(options) {
      if (typeof options === "boolean") {
        options = {
          children: options
        };
      }

      options = Object.assign({}, defaultDestroyOptions, options);

      _get(_getPrototypeOf(Text.prototype), "destroy", this).call(this, options);

      this.context = null;
      this.canvas = null;
      this._style = null;
    }
  }, {
    key: "width",
    get: function get() {
      this.updateText(true);
      return Math.abs(this.scale.x) * this._texture.orig.width;
    },
    set: function set(value) {
      this.updateText(true);
      var s = (0, _utils.sign)(this.scale.x) || 1;
      this.scale.x = s * value / this._texture.orig.width;
      this._width = value;
    }
  }, {
    key: "height",
    get: function get() {
      this.updateText(true);
      return Math.abs(this.scale.y) * this._texture.orig.height;
    },
    set: function set(value) {
      this.updateText(true);
      var s = (0, _utils.sign)(this.scale.y) || 1;
      this.scale.y = s * value / this._texture.orig.height;
      this._height = value;
    }
  }, {
    key: "style",
    get: function get() {
      return this._style;
    },
    set: function set(style) {
      style = style || {};

      if (style instanceof _TextStyle["default"]) {
        this._style = style;
      } else {
        this._style = new _TextStyle["default"](style);
      }

      this.localStyleID = -1;
      this.dirty = true;
    }
  }, {
    key: "text",
    get: function get() {
      return this._text;
    },
    set: function set(text) {
      text = String(text === "" || text === null || text === undefined ? " " : text);

      if (this._text === text) {
        return;
      }

      this._text = text;
      this.dirty = true;
    }
  }]);

  return Text;
}(_Sprite2["default"]);

exports["default"] = Text;
//# sourceMappingURL=Text.js.map