"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _const = require("../const");

var _utils = require("../utils");

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var defaultStyle = {
  align: "left",
  breakWords: false,
  dropShadow: false,
  dropShadowAlpha: 1,
  dropShadowAngle: Math.PI / 6,
  dropShadowBlur: 0,
  dropShadowColor: "black",
  dropShadowDistance: 5,
  fill: "black",
  fillGradientType: _const.TEXT_GRADIENT.LINEAR_VERTICAL,
  fillGradientStops: [],
  fontFamily: "Arial",
  fontSize: 26,
  fontStyle: "normal",
  fontVariant: "normal",
  fontWeight: "normal",
  letterSpacing: 0,
  lineHeight: 0,
  lineJoin: "miter",
  miterLimit: 10,
  padding: 0,
  stroke: "black",
  strokeThickness: 0,
  textBaseline: "alphabetic",
  trim: false,
  whiteSpace: "pre",
  wordWrap: false,
  wordWrapWidth: 100,
  leading: 0
};
var genericFontFamilies = ["serif", "sans-serif", "monospace", "cursive", "fantasy", "system-ui"];

var TextStyle = /*#__PURE__*/function () {
  function TextStyle(style) {
    _classCallCheck(this, TextStyle);

    this.styleID = 0;
    this.reset();
    deepCopyProperties(this, style, style);
  }

  _createClass(TextStyle, [{
    key: "clone",
    value: function clone() {
      var clonedProperties = {};
      deepCopyProperties(clonedProperties, this, defaultStyle);
      return new TextStyle(clonedProperties);
    }
  }, {
    key: "reset",
    value: function reset() {
      deepCopyProperties(this, defaultStyle, defaultStyle);
    }
  }, {
    key: "align",
    get: function get() {
      return this._align;
    },
    set: function set(align) {
      if (this._align !== align) {
        this._align = align;
        this.styleID++;
      }
    }
  }, {
    key: "breakWords",
    get: function get() {
      return this._breakWords;
    },
    set: function set(breakWords) {
      if (this._breakWords !== breakWords) {
        this._breakWords = breakWords;
        this.styleID++;
      }
    }
  }, {
    key: "dropShadow",
    get: function get() {
      return this._dropShadow;
    },
    set: function set(dropShadow) {
      if (this._dropShadow !== dropShadow) {
        this._dropShadow = dropShadow;
        this.styleID++;
      }
    }
  }, {
    key: "dropShadowAlpha",
    get: function get() {
      return this._dropShadowAlpha;
    },
    set: function set(dropShadowAlpha) {
      if (this._dropShadowAlpha !== dropShadowAlpha) {
        this._dropShadowAlpha = dropShadowAlpha;
        this.styleID++;
      }
    }
  }, {
    key: "dropShadowAngle",
    get: function get() {
      return this._dropShadowAngle;
    },
    set: function set(dropShadowAngle) {
      if (this._dropShadowAngle !== dropShadowAngle) {
        this._dropShadowAngle = dropShadowAngle;
        this.styleID++;
      }
    }
  }, {
    key: "dropShadowBlur",
    get: function get() {
      return this._dropShadowBlur;
    },
    set: function set(dropShadowBlur) {
      if (this._dropShadowBlur !== dropShadowBlur) {
        this._dropShadowBlur = dropShadowBlur;
        this.styleID++;
      }
    }
    /**
     * A fill style to be used on the dropshadow e.g 'red', '#00FF00'
     *
     * @member {string|number}
     */

  }, {
    key: "dropShadowColor",
    get: function get() {
      return this._dropShadowColor;
    },
    set: function set(dropShadowColor) {
      var outputColor = getColor(dropShadowColor);

      if (this._dropShadowColor !== outputColor) {
        this._dropShadowColor = outputColor;
        this.styleID++;
      }
    }
  }, {
    key: "dropShadowDistance",
    get: function get() {
      return this._dropShadowDistance;
    },
    set: function set(dropShadowDistance) {
      if (this._dropShadowDistance !== dropShadowDistance) {
        this._dropShadowDistance = dropShadowDistance;
        this.styleID++;
      }
    }
  }, {
    key: "fill",
    get: function get() {
      return this._fill;
    },
    set: function set(fill) {
      var outputColor = getColor(fill);

      if (this._fill !== outputColor) {
        this._fill = outputColor;
        this.styleID++;
      }
    }
  }, {
    key: "fillGradientType",
    get: function get() {
      return this._fillGradientType;
    },
    set: function set(fillGradientType) {
      if (this._fillGradientType !== fillGradientType) {
        this._fillGradientType = fillGradientType;
        this.styleID++;
      }
    }
  }, {
    key: "fillGradientStops",
    get: function get() {
      return this._fillGradientStops;
    },
    set: function set(fillGradientStops) {
      if (!areArraysEqual(this._fillGradientStops, fillGradientStops)) {
        this._fillGradientStops = fillGradientStops;
        this.styleID++;
      }
    }
  }, {
    key: "fontFamily",
    get: function get() {
      return this._fontFamily;
    },
    set: function set(fontFamily) {
      if (this.fontFamily !== fontFamily) {
        this._fontFamily = fontFamily;
        this.styleID++;
      }
    }
  }, {
    key: "fontSize",
    get: function get() {
      return this._fontSize;
    },
    set: function set(fontSize) {
      if (this._fontSize !== fontSize) {
        this._fontSize = fontSize;
        this.styleID++;
      }
    }
    /**
     * The font style
     * ('normal', 'italic' or 'oblique')
     *
     * @member {string}
     */

  }, {
    key: "fontStyle",
    get: function get() {
      return this._fontStyle;
    },
    set: function set(fontStyle) {
      if (this._fontStyle !== fontStyle) {
        this._fontStyle = fontStyle;
        this.styleID++;
      }
    }
    /**
     * The font variant
     * ('normal' or 'small-caps')
     *
     * @member {string}
     */

  }, {
    key: "fontVariant",
    get: function get() {
      return this._fontVariant;
    },
    set: function set(fontVariant) {
      if (this._fontVariant !== fontVariant) {
        this._fontVariant = fontVariant;
        this.styleID++;
      }
    }
    /**
     * The font weight
     * ('normal', 'bold', 'bolder', 'lighter' and '100', '200', '300', '400', '500', '600', '700', 800' or '900')
     *
     * @member {string}
     */

  }, {
    key: "fontWeight",
    get: function get() {
      return this._fontWeight;
    },
    set: function set(fontWeight) {
      if (this._fontWeight !== fontWeight) {
        this._fontWeight = fontWeight;
        this.styleID++;
      }
    }
    /**
     * The amount of spacing between letters, default is 0
     *
     * @member {number}
     */

  }, {
    key: "letterSpacing",
    get: function get() {
      return this._letterSpacing;
    },
    set: function set(letterSpacing) {
      if (this._letterSpacing !== letterSpacing) {
        this._letterSpacing = letterSpacing;
        this.styleID++;
      }
    }
    /**
     * The line height, a number that represents the vertical space that a letter uses
     *
     * @member {number}
     */

  }, {
    key: "lineHeight",
    get: function get() {
      return this._lineHeight;
    },
    set: function set(lineHeight) {
      if (this._lineHeight !== lineHeight) {
        this._lineHeight = lineHeight;
        this.styleID++;
      }
    }
    /**
     * The space between lines
     *
     * @member {number}
     */

  }, {
    key: "leading",
    get: function get() {
      return this._leading;
    },
    set: function set(leading) {
      if (this._leading !== leading) {
        this._leading = leading;
        this.styleID++;
      }
    }
    /**
     * The lineJoin property sets the type of corner created, it can resolve spiked text issues.
     * Default is 'miter' (creates a sharp corner).
     *
     * @member {string}
     */

  }, {
    key: "lineJoin",
    get: function get() {
      return this._lineJoin;
    },
    set: function set(lineJoin) {
      if (this._lineJoin !== lineJoin) {
        this._lineJoin = lineJoin;
        this.styleID++;
      }
    }
    /**
     * The miter limit to use when using the 'miter' lineJoin mode
     * This can reduce or increase the spikiness of rendered text.
     *
     * @member {number}
     */

  }, {
    key: "miterLimit",
    get: function get() {
      return this._miterLimit;
    },
    set: function set(miterLimit) {
      if (this._miterLimit !== miterLimit) {
        this._miterLimit = miterLimit;
        this.styleID++;
      }
    }
  }, {
    key: "padding",
    get: function get() {
      return this._padding;
    },
    set: function set(padding) {
      if (this._padding !== padding) {
        this._padding = padding;
        this.styleID++;
      }
    }
  }, {
    key: "stroke",
    get: function get() {
      return this._stroke;
    },
    set: function set(stroke) {
      var outputColor = getColor(stroke);

      if (this._stroke !== outputColor) {
        this._stroke = outputColor;
        this.styleID++;
      }
    }
    /**
     * A number that represents the thickness of the stroke.
     * Default is 0 (no stroke)
     *
     * @member {number}
     */

  }, {
    key: "strokeThickness",
    get: function get() {
      return this._strokeThickness;
    },
    set: function set(strokeThickness) {
      if (this._strokeThickness !== strokeThickness) {
        this._strokeThickness = strokeThickness;
        this.styleID++;
      }
    }
    /**
     * The baseline of the text that is rendered.
     *
     * @member {string}
     */

  }, {
    key: "textBaseline",
    get: function get() {
      return this._textBaseline;
    },
    set: function set(textBaseline) {
      if (this._textBaseline !== textBaseline) {
        this._textBaseline = textBaseline;
        this.styleID++;
      }
    }
    /**
     * Trim transparent borders
     *
     * @member {boolean}
     */

  }, {
    key: "trim",
    get: function get() {
      return this._trim;
    },
    set: function set(trim) {
      if (this._trim !== trim) {
        this._trim = trim;
        this.styleID++;
      }
    }
  }, {
    key: "whiteSpace",
    get: function get() {
      return this._whiteSpace;
    },
    set: function set(whiteSpace) {
      if (this._whiteSpace !== whiteSpace) {
        this._whiteSpace = whiteSpace;
        this.styleID++;
      }
    }
  }, {
    key: "wordWrap",
    get: function get() {
      return this._wordWrap;
    },
    set: function set(wordWrap) {
      if (this._wordWrap !== wordWrap) {
        this._wordWrap = wordWrap;
        this.styleID++;
      }
    }
    /**
     * The width at which text will wrap, it needs wordWrap to be set to true
     *
     * @member {number}
     */

  }, {
    key: "wordWrapWidth",
    get: function get() {
      return this._wordWrapWidth;
    },
    set: function set(wordWrapWidth) {
      if (this._wordWrapWidth !== wordWrapWidth) {
        this._wordWrapWidth = wordWrapWidth;
        this.styleID++;
      }
    }
  }, {
    key: "toFontString",
    value: function toFontString() {
      // build canvas api font setting from individual components. Convert a numeric this.fontSize to px
      var fontSizeString = typeof this.fontSize === "number" ? "".concat(this.fontSize, "px") : this.fontSize; // Clean-up fontFamily property by quoting each font name
      // this will support font names with spaces

      var fontFamilies = this.fontFamily;

      if (!Array.isArray(this.fontFamily)) {
        fontFamilies = this.fontFamily.split(",");
      }

      for (var i = fontFamilies.length - 1; i >= 0; i--) {
        // Trim any extra white-space
        var fontFamily = fontFamilies[i].trim(); // Check if font is already escaped in quotes except for CSS generic fonts

        if (!/([\"\'])[^\'\"]+\1/.test(fontFamily) && genericFontFamilies.indexOf(fontFamily) < 0) {
          fontFamily = "\"".concat(fontFamily, "\"");
        }

        fontFamilies[i] = fontFamily;
      }

      return "".concat(this.fontStyle, " ").concat(this.fontVariant, " ").concat(this.fontWeight, " ").concat(fontSizeString, " ").concat(fontFamilies.join(","));
    }
  }]);

  return TextStyle;
}();

exports["default"] = TextStyle;

function getSingleColor(color) {
  if (typeof color === "number") {
    return (0, _utils.hex2string)(color);
  } else if (typeof color === "string") {
    if (color.indexOf("0x") === 0) {
      color = color.replace("0x", "#");
    }
  }

  return color;
}

function getColor(color) {
  if (!Array.isArray(color)) return getSingleColor(color);

  for (var i = 0; i < color.length; ++i) {
    color[i] = getSingleColor(color[i]);
  }

  return color;
}

function areArraysEqual(array1, array2) {
  if (!Array.isArray(array1) || !Array.isArray(array2)) {
    return false;
  }

  if (array1.length !== array2.length) {
    return false;
  }

  for (var i = 0; i < array1.length; ++i) {
    if (array1[i] !== array2[i]) {
      return false;
    }
  }

  return true;
}

function deepCopyProperties(target, source, propertyObj) {
  for (var prop in propertyObj) {
    if (Array.isArray(source[prop])) {
      target[prop] = source[prop].slice();
    } else {
      target[prop] = source[prop];
    }
  }
}
//# sourceMappingURL=TextStyle.js.map