"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _utils = require("../utils");

var _Image = _interopRequireDefault(require("../polyfill/Image"));

var _settings = _interopRequireDefault(require("../settings"));

var _bitTwiddle = _interopRequireDefault(require("bit-twiddle"));

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var BaseTexture = /*#__PURE__*/function (_EventEmitter) {
  _inherits(BaseTexture, _EventEmitter);

  var _super = _createSuper(BaseTexture);

  function BaseTexture(source, scaleMode, resolution) {
    var _this;

    _classCallCheck(this, BaseTexture);

    _this = _super.call(this);
    _this.uid = (0, _utils.uid)();
    _this.touched = 0;
    _this.width = 100;
    _this.height = 100;
    _this.realWidth = 100;
    _this.realHeight = 100;
    _this.resolution = resolution || _settings["default"].RESOLUTION;
    _this.scaleMode = scaleMode !== undefined ? scaleMode : _settings["default"].SCALE_MODE;
    _this.hasLoaded = false;
    _this.isLoading = false;
    _this.source = null; // set in loadSource, if at all

    _this.imageType = null; // set in updateImageType

    _this.sourceScale = 1.0;
    _this.premultipliedAlpha = true;
    _this.imageUrl = null;
    _this.isPowerOfTwo = false;
    _this.mipmap = _settings["default"].MIPMAP_TEXTURES;
    _this.wrapMode = _settings["default"].WRAP_MODE;
    _this._glTextures = {};
    _this._enabled = 0;
    _this._virtalBoundId = -1;
    _this._destroyed = false;
    _this.textureCacheIds = [];
    if (source) _this.loadSource(source);
    return _this;
  }

  _createClass(BaseTexture, [{
    key: "loadSource",
    value: function loadSource(source) {
      var wasLoading = this.isLoading;
      this.hasLoaded = false;
      this.isLoading = false;

      if (wasLoading && this.source) {
        this.source.onload = null;
        this.source.onerror = null;
      }

      var firstSourceLoaded = !this.source;
      this.source = source; // source resources loaded

      if ((source.src && source.complete || source.getContext) && source.width && source.height) {
        this._updateImageType();

        this._sourceLoaded();

        if (firstSourceLoaded) this.emit("loaded", this);
      } // the resource is not loaded
      else if (!source.getContext) {
          this.isLoading = true;
          var scope = this;

          source.onload = function () {
            scope._updateImageType();

            source.onload = null;
            source.onerror = null;
            if (!scope.isLoading) return;
            scope.isLoading = false;

            scope._sourceLoaded();

            scope.emit("loaded", scope);
          };

          source.onerror = function () {
            source.onload = null;
            source.onerror = null;
            if (!scope.isLoading) return;
            scope.isLoading = false;
            scope.emit("error", scope);
          };

          if (source.complete && source.src) {
            source.onload = null;
            source.onerror = null;
            this.isLoading = false;

            if (source.width && source.height) {
              this._sourceLoaded();

              if (wasLoading) this.emit("loaded", this);
            } else if (wasLoading) {
              this.emit("error", this);
            }
          }
        }
    }
  }, {
    key: "updateSourceImage",
    value: function updateSourceImage(imageUrl) {
      if (!this.source) this.source = this.createPsImage(imageUrl);
      this.source.src = imageUrl;
      this.loadSource(this.source);
    }
  }, {
    key: "createPsImage",
    value: function createPsImage(imageUrl) {
      var image = new _Image["default"]();
      this.imageUrl = imageUrl;
      this.resolution = (0, _utils.getResolutionOfUrl)(imageUrl);
      image.src = imageUrl;
      return image;
    }
  }, {
    key: "update",
    value: function update() {
      if (this.imageType !== "svg") {
        this.realWidth = this.source.naturalWidth || this.source.videoWidth || this.source.width;
        this.realHeight = this.source.naturalHeight || this.source.videoHeight || this.source.height;

        this._updateDimensions();
      }

      this.emit("update", this);
    }
  }, {
    key: "_updateDimensions",
    value: function _updateDimensions() {
      this.width = this.realWidth / this.resolution;
      this.height = this.realHeight / this.resolution;
      this.isPowerOfTwo = _bitTwiddle["default"].isPow2(this.realWidth) && _bitTwiddle["default"].isPow2(this.realHeight);
    }
  }, {
    key: "_updateImageType",
    value: function _updateImageType() {
      if (!this.imageUrl) return;
      var dataUri = (0, _utils.decomposeDataUri)(this.imageUrl);
      var imageType;

      if (dataUri && dataUri.mediaType === "image") {
        var firstSubType = dataUri.subType.split("+")[0];
        imageType = (0, _utils.getUrlFileExt)(".".concat(firstSubType));
      } else {
        imageType = (0, _utils.getUrlFileExt)(this.imageUrl);
      }

      this.imageType = imageType || "png";
    }
  }, {
    key: "_sourceLoaded",
    value: function _sourceLoaded() {
      this.hasLoaded = true;
      this.update();
    }
  }, {
    key: "destroy",
    value: function destroy() {
      if (this.imageUrl) {
        delete _utils.TextureCache[this.imageUrl];
        this.imageUrl = null;
        this.source.src = "";
      }

      this.source = null;
      this.dispose();
      BaseTexture.removeFromCache(this);
      this.textureCacheIds = null;
      this._destroyed = true;
    }
  }, {
    key: "dispose",
    value: function dispose() {
      this.emit("dispose", this);
    }
  }], [{
    key: "fromImage",
    value: function fromImage(imageUrl, crossorigin, scaleMode, sourceScale) {
      var baseTexture = _utils.BaseTextureCache[imageUrl];

      if (!baseTexture) {
        var image = new _Image["default"]();
        baseTexture = new BaseTexture(image, scaleMode);
        baseTexture.imageUrl = imageUrl;
        if (sourceScale) baseTexture.sourceScale = sourceScale;
        baseTexture.resolution = (0, _utils.getResolutionOfUrl)(imageUrl);
        image.src = imageUrl;
        BaseTexture.addToCache(baseTexture, imageUrl);
      }

      return baseTexture;
    }
  }, {
    key: "fromCanvas",
    value: function fromCanvas(canvas, scaleMode) {
      var origin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "canvas";

      if (!canvas._pixiId) {
        canvas._pixiId = "".concat(origin, "_").concat((0, _utils.uid)());
      }

      var baseTexture = _utils.BaseTextureCache[canvas._pixiId];

      if (!baseTexture) {
        baseTexture = new BaseTexture(canvas, scaleMode);
        BaseTexture.addToCache(baseTexture, canvas._pixiId);
      }

      return baseTexture;
    }
  }, {
    key: "from",
    value: function from(source, scaleMode, sourceScale) {
      if (typeof source === "string") {
        return BaseTexture.fromImage(source, undefined, scaleMode, sourceScale);
      } else if (source instanceof HTMLImageElement) {
        var imageUrl = source.src;
        var baseTexture = _utils.BaseTextureCache[imageUrl];

        if (!baseTexture) {
          baseTexture = new BaseTexture(source, scaleMode);
          baseTexture.imageUrl = imageUrl;

          if (sourceScale) {
            baseTexture.sourceScale = sourceScale;
          } // if there is an @2x at the end of the url we are going to assume its a highres image


          baseTexture.resolution = (0, _utils.getResolutionOfUrl)(imageUrl);
          BaseTexture.addToCache(baseTexture, imageUrl);
        }

        return baseTexture;
      } else if (source instanceof HTMLCanvasElement) {
        return BaseTexture.fromCanvas(source, scaleMode);
      } // lets assume its a base texture!


      return source;
    }
  }, {
    key: "addToCache",
    value: function addToCache(baseTexture, id) {
      if (id) {
        if (baseTexture.textureCacheIds.indexOf(id) === -1) {
          baseTexture.textureCacheIds.push(id);
        }

        if (_utils.BaseTextureCache[id]) {
          console.warn("BaseTexture added to the cache with an id [".concat(id, "] that already had an entry"));
        }

        _utils.BaseTextureCache[id] = baseTexture;
      }
    }
  }, {
    key: "removeFromCache",
    value: function removeFromCache(baseTexture) {
      if (typeof baseTexture === "string") {
        var baseTextureFromCache = _utils.BaseTextureCache[baseTexture];

        if (baseTextureFromCache) {
          var index = baseTextureFromCache.textureCacheIds.indexOf(baseTexture);

          if (index > -1) {
            baseTextureFromCache.textureCacheIds.splice(index, 1);
          }

          delete _utils.BaseTextureCache[baseTexture];
          return baseTextureFromCache;
        }
      } else if (baseTexture && baseTexture.textureCacheIds) {
        for (var i = 0; i < baseTexture.textureCacheIds.length; ++i) {
          delete _utils.BaseTextureCache[baseTexture.textureCacheIds[i]];
        }

        baseTexture.textureCacheIds.length = 0;
        return baseTexture;
      }

      return null;
    }
  }]);

  return BaseTexture;
}(_eventemitter["default"]);

exports["default"] = BaseTexture;
//# sourceMappingURL=BaseTexture.js.map