"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _BaseTexture = _interopRequireDefault(require("./BaseTexture"));

var _VideoBaseTexture = _interopRequireDefault(require("./VideoBaseTexture"));

var _TextureUvs = _interopRequireDefault(require("./TextureUvs"));

var _eventemitter = _interopRequireDefault(require("eventemitter3"));

var _math = require("../math");

var _utils = require("../utils");

var _settings = _interopRequireDefault(require("../settings"));

var _Image = _interopRequireDefault(require("../polyfill/Image"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Texture = /*#__PURE__*/function (_EventEmitter) {
  _inherits(Texture, _EventEmitter);

  var _super = _createSuper(Texture);

  function Texture(baseTexture, frame, orig, trim, rotate, anchor) {
    var _this;

    _classCallCheck(this, Texture);

    _this = _super.call(this);
    _this.noFrame = false;

    if (!frame) {
      _this.noFrame = true;
      frame = new _math.Rectangle(0, 0, 1, 1);
    }

    if (baseTexture instanceof Texture) {
      baseTexture = baseTexture.baseTexture;
    }

    _this.baseTexture = baseTexture;
    _this._frame = frame;
    _this.trim = trim;
    _this.valid = false;
    _this.requiresUpdate = false;
    _this._uvs = null;
    _this.orig = orig || frame;
    _this._rotate = Number(rotate || 0);

    if (rotate === true) {
      _this._rotate = 2;
    } else if (_this._rotate % 2 !== 0) {
      throw new Error("attempt to use diamond-shaped UVs.");
    } ////////////////////////////////////////////////////////////////////////////////////


    if (baseTexture.hasLoaded) {
      if (_this.noFrame) {
        frame = new _math.Rectangle(0, 0, baseTexture.width, baseTexture.height);
        baseTexture.on("update", _this.onBaseTextureUpdated, _assertThisInitialized(_this));
      }

      _this.frame = frame;

      _this.adaptedTexture(baseTexture);
    } else {
      baseTexture.once("loaded", _this.onBaseTextureLoaded, _assertThisInitialized(_this));
    }

    baseTexture.on("error", _this.onBaseTextureError, _assertThisInitialized(_this)); ////////////////////////////////////////////////////////////////////////////////////

    _this.defaultAnchor = anchor ? new _math.Point(anchor.x, anchor.y) : new _math.Point(0, 0);
    _this._updateID = 0;
    _this.transform = null;
    _this.textureCacheIds = [];
    return _this;
  }

  _createClass(Texture, [{
    key: "adaptedTexture",
    value: function adaptedTexture(baseTexture) {
      if (baseTexture.source && baseTexture.source.isPsImage) {
        baseTexture.source = _Image["default"].convertToImageData(baseTexture.source);
      }
    }
  }, {
    key: "update",
    value: function update() {
      this.baseTexture.update();
    }
  }, {
    key: "onBaseTextureLoaded",
    value: function onBaseTextureLoaded(baseTexture) {
      this._updateID++;

      if (this.noFrame) {
        this.frame = new _math.Rectangle(0, 0, baseTexture.width, baseTexture.height);
      } else {
        this.frame = this._frame;
      }

      this.adaptedTexture(baseTexture);
      this.baseTexture.on("update", this.onBaseTextureUpdated, this);
      this.emit("update", this);
    }
  }, {
    key: "onBaseTextureError",
    value: function onBaseTextureError(e) {
      this.emit("error", e);
    }
  }, {
    key: "onBaseTextureUpdated",
    value: function onBaseTextureUpdated(baseTexture) {
      this._updateID++;
      this._frame.width = baseTexture.width;
      this._frame.height = baseTexture.height;
      this.emit("update", this);
    }
  }, {
    key: "destroy",
    value: function destroy(destroyBase) {
      if (this.baseTexture) {
        if (destroyBase) {
          if (_utils.TextureCache[this.baseTexture.imageUrl]) {
            Texture.removeFromCache(this.baseTexture.imageUrl);
          }

          this.baseTexture.destroy();
        }

        this.baseTexture.off("update", this.onBaseTextureUpdated, this);
        this.baseTexture.off("loaded", this.onBaseTextureLoaded, this);
        this.baseTexture.off("error", this.onBaseTextureError, this);
        this.baseTexture = null;
      }

      this._frame = null;
      this._uvs = null;
      this.trim = null;
      this.orig = null;
      this.valid = false;
      Texture.removeFromCache(this);
      this.textureCacheIds = null;
    }
  }, {
    key: "clone",
    value: function clone() {
      return new Texture(this.baseTexture, this.frame, this.orig, this.trim, this.rotate, this.defaultAnchor);
    }
  }, {
    key: "_updateUvs",
    value: function _updateUvs() {
      if (!this._uvs) this._uvs = new _TextureUvs["default"]();

      this._uvs.set(this._frame, this.baseTexture, this.rotate);

      this._updateID++;
    }
  }, {
    key: "frame",
    get: function get() {
      return this._frame;
    },
    set: function set(frame) {
      this._frame = frame;
      this.noFrame = false;
      var x = frame.x,
          y = frame.y,
          width = frame.width,
          height = frame.height;
      var xNotFit = x + width > this.baseTexture.width;
      var yNotFit = y + height > this.baseTexture.height;

      if (xNotFit || yNotFit) {
        var relationship = xNotFit && yNotFit ? "and" : "or";
        var errorX = "X: ".concat(x, " + ").concat(width, " = ").concat(x + width, " > ").concat(this.baseTexture.width);
        var errorY = "Y: ".concat(y, " + ").concat(height, " = ").concat(y + height, " > ").concat(this.baseTexture.height);
        throw new Error("Texture Error: frame does not fit inside the base Texture dimensions: " + "".concat(errorX, " ").concat(relationship, " ").concat(errorY));
      }

      this.valid = width && height && this.baseTexture.hasLoaded;

      if (!this.trim && !this.rotate) {
        this.orig = frame;
      }

      if (this.valid) {
        this._updateUvs();
      }
    }
  }, {
    key: "rotate",
    get: function get() {
      return this._rotate;
    },
    set: function set(rotate) {
      this._rotate = rotate;

      if (this.valid) {
        this._updateUvs();
      }
    }
  }, {
    key: "width",
    get: function get() {
      return this.orig.width;
    }
  }, {
    key: "height",
    get: function get() {
      return this.orig.height;
    }
  }], [{
    key: "fromImage",
    value: function fromImage(imageUrl, crossorigin, scaleMode, sourceScale) {
      var texture = _utils.TextureCache[imageUrl];

      if (!texture) {
        texture = new Texture(_BaseTexture["default"].fromImage(imageUrl, crossorigin, scaleMode, sourceScale));
        Texture.addToCache(texture, imageUrl);
      }

      return texture;
    }
  }, {
    key: "fromFrame",
    value: function fromFrame(frameId) {
      var texture = _utils.TextureCache[frameId];

      if (!texture) {
        throw new Error("The frameId \"".concat(frameId, "\" does not exist in the texture cache"));
      }

      return texture;
    }
  }, {
    key: "fromCanvas",
    value: function fromCanvas(canvas, scaleMode) {
      var origin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "canvas";
      return new Texture(_BaseTexture["default"].fromCanvas(canvas, scaleMode, origin));
    }
  }, {
    key: "fromVideo",
    value: function fromVideo(video, scaleMode, crossorigin, autoPlay) {
      if (typeof video === "string") {
        return Texture.fromVideoUrl(video, scaleMode, crossorigin, autoPlay);
      }

      return new Texture(_VideoBaseTexture["default"].fromVideo(video, scaleMode, autoPlay));
    }
  }, {
    key: "fromVideoUrl",
    value: function fromVideoUrl(videoUrl, scaleMode, crossorigin, autoPlay) {
      return new Texture(_VideoBaseTexture["default"].fromUrl(videoUrl, scaleMode, crossorigin, autoPlay));
    }
  }, {
    key: "from",
    value: function from(source) {
      if (typeof source === "string") {
        var texture = _utils.TextureCache[source];

        if (!texture) {
          var isVideo = source.match(/\.(mp4|webm|ogg|h264|avi|mov)$/) !== null;
          if (isVideo) return Texture.fromVideoUrl(source);
          return Texture.fromImage(source);
        }

        return texture;
      } else if (source instanceof HTMLImageElement) {
        return new Texture(_BaseTexture["default"].from(source));
      } else if (source instanceof HTMLCanvasElement) {
        return Texture.fromCanvas(source, _settings["default"].SCALE_MODE, "HTMLCanvasElement");
      } else if (source instanceof HTMLVideoElement) {
        return Texture.fromVideo(source);
      } else if (source instanceof _BaseTexture["default"]) {
        return new Texture(source);
      }

      return source;
    }
  }, {
    key: "fromLoader",
    value: function fromLoader(source, imageUrl, name) {
      var baseTexture = new _BaseTexture["default"](source, undefined, (0, _utils.getResolutionOfUrl)(imageUrl));
      var texture = new Texture(baseTexture);
      baseTexture.imageUrl = imageUrl;
      if (!name) name = imageUrl;

      _BaseTexture["default"].addToCache(texture.baseTexture, name);

      Texture.addToCache(texture, name);

      if (name !== imageUrl) {
        _BaseTexture["default"].addToCache(texture.baseTexture, imageUrl);

        Texture.addToCache(texture, imageUrl);
      }

      return texture;
    }
  }, {
    key: "addToCache",
    value: function addToCache(texture, id) {
      if (id) {
        if (texture.textureCacheIds.indexOf(id) === -1) {
          texture.textureCacheIds.push(id);
        }

        if (_utils.TextureCache[id]) {
          console.warn("Texture added to the cache with an id [".concat(id, "] that already had an entry"));
        }

        _utils.TextureCache[id] = texture;
      }
    }
  }, {
    key: "removeFromCache",
    value: function removeFromCache(texture) {
      if (typeof texture === "string") {
        var textureFromCache = _utils.TextureCache[texture];

        if (textureFromCache) {
          var index = textureFromCache.textureCacheIds.indexOf(texture);

          if (index > -1) {
            textureFromCache.textureCacheIds.splice(index, 1);
          }

          delete _utils.TextureCache[texture];
          return textureFromCache;
        }
      } else if (texture && texture.textureCacheIds) {
        for (var i = 0; i < texture.textureCacheIds.length; ++i) {
          if (_utils.TextureCache[texture.textureCacheIds[i]] === texture) {
            delete _utils.TextureCache[texture.textureCacheIds[i]];
          }
        }

        texture.textureCacheIds.length = 0;
        return texture;
      }

      return null;
    }
  }]);

  return Texture;
}(_eventemitter["default"]);

exports["default"] = Texture;

function removeAllHandlers(tex) {
  tex.destroy = function _emptyDestroy() {
    /* empty */
  };

  tex.on = function _emptyOn() {
    /* empty */
  };

  tex.once = function _emptyOnce() {
    /* empty */
  };

  tex.emit = function _emptyEmit() {
    /* empty */
  };
}

Texture.EMPTY = new Texture(new _BaseTexture["default"]());
removeAllHandlers(Texture.EMPTY);
removeAllHandlers(Texture.EMPTY.baseTexture);
//# sourceMappingURL=Texture.js.map