"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _BaseTexture2 = _interopRequireDefault(require("./BaseTexture"));

var _ticker = require("../ticker");

var _const = require("../const");

var _utils = require("../utils");

var _determineCrossOrigin = _interopRequireDefault(require("../utils/determineCrossOrigin"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _get(target, property, receiver) { if (typeof Reflect !== "undefined" && Reflect.get) { _get = Reflect.get; } else { _get = function _get(target, property, receiver) { var base = _superPropBase(target, property); if (!base) return; var desc = Object.getOwnPropertyDescriptor(base, property); if (desc.get) { return desc.get.call(receiver); } return desc.value; }; } return _get(target, property, receiver || target); }

function _superPropBase(object, property) { while (!Object.prototype.hasOwnProperty.call(object, property)) { object = _getPrototypeOf(object); if (object === null) break; } return object; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var VideoBaseTexture = /*#__PURE__*/function (_BaseTexture) {
  _inherits(VideoBaseTexture, _BaseTexture);

  var _super = _createSuper(VideoBaseTexture);

  function VideoBaseTexture(source, scaleMode) {
    var _this;

    var autoPlay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

    _classCallCheck(this, VideoBaseTexture);

    if (!source) {
      throw new Error("No video source element specified.");
    }

    if ((source.readyState === source.HAVE_ENOUGH_DATA || source.readyState === source.HAVE_FUTURE_DATA) && source.width && source.height) {
      source.complete = true;
    }

    _this = _super.call(this, source, scaleMode);
    _this.width = source.videoWidth;
    _this.height = source.videoHeight;
    _this._autoUpdate = true;
    _this._isAutoUpdating = false;
    _this.autoPlay = autoPlay;
    _this.update = _this.update.bind(_assertThisInitialized(_this));
    _this._onCanPlay = _this._onCanPlay.bind(_assertThisInitialized(_this));
    source.addEventListener("play", _this._onPlayStart.bind(_assertThisInitialized(_this)));
    source.addEventListener("pause", _this._onPlayStop.bind(_assertThisInitialized(_this)));
    _this.hasLoaded = false;
    _this.__loaded = false;

    if (!_this._isSourceReady()) {
      source.addEventListener("canplay", _this._onCanPlay);
      source.addEventListener("canplaythrough", _this._onCanPlay);
    } else {
      _this._onCanPlay();
    }

    return _this;
  }

  _createClass(VideoBaseTexture, [{
    key: "_isSourcePlaying",
    value: function _isSourcePlaying() {
      var source = this.source;
      return source.currentTime > 0 && source.paused === false && source.ended === false && source.readyState > 2;
    }
  }, {
    key: "_isSourceReady",
    value: function _isSourceReady() {
      return this.source.readyState === 3 || this.source.readyState === 4;
    }
  }, {
    key: "_onPlayStart",
    value: function _onPlayStart() {
      // Just in case the video has not received its can play even yet..
      if (!this.hasLoaded) {
        this._onCanPlay();
      }

      if (!this._isAutoUpdating && this.autoUpdate) {
        _ticker.shared.add(this.update, this, _const.UPDATE_PRIORITY.HIGH);

        this._isAutoUpdating = true;
      }
    }
  }, {
    key: "_onPlayStop",
    value: function _onPlayStop() {
      if (this._isAutoUpdating) {
        _ticker.shared.remove(this.update, this);

        this._isAutoUpdating = false;
      }
    }
  }, {
    key: "_onCanPlay",
    value: function _onCanPlay() {
      this.hasLoaded = true;

      if (this.source) {
        this.source.removeEventListener("canplay", this._onCanPlay);
        this.source.removeEventListener("canplaythrough", this._onCanPlay);
        this.width = this.source.videoWidth;
        this.height = this.source.videoHeight;

        if (!this.__loaded) {
          this.__loaded = true;
          this.emit("loaded", this);
        }

        if (this._isSourcePlaying()) {
          this._onPlayStart();
        } else if (this.autoPlay) {
          this.source.play();
        }
      }
    }
  }, {
    key: "destroy",
    value: function destroy() {
      if (this._isAutoUpdating) {
        _ticker.shared.remove(this.update, this);
      }

      if (this.source && this.source._pixiId) {
        _BaseTexture2["default"].removeFromCache(this.source._pixiId);

        delete this.source._pixiId;
        this.source.pause();
        this.source.src = "";
        this.source.load();
      }

      _get(_getPrototypeOf(VideoBaseTexture.prototype), "destroy", this).call(this);
    }
  }, {
    key: "autoUpdate",
    get: function get() {
      return this._autoUpdate;
    },
    set: function set(value) {
      if (value !== this._autoUpdate) {
        this._autoUpdate = value;

        if (!this._autoUpdate && this._isAutoUpdating) {
          _ticker.shared.remove(this.update, this);

          this._isAutoUpdating = false;
        } else if (this._autoUpdate && !this._isAutoUpdating) {
          _ticker.shared.add(this.update, this, _const.UPDATE_PRIORITY.HIGH);

          this._isAutoUpdating = true;
        }
      }
    }
  }], [{
    key: "fromVideo",
    value: function fromVideo(video, scaleMode, autoPlay) {
      if (!video._pixiId) {
        video._pixiId = "video_".concat((0, _utils.uid)());
      }

      var baseTexture = _utils.BaseTextureCache[video._pixiId];

      if (!baseTexture) {
        baseTexture = new VideoBaseTexture(video, scaleMode, autoPlay);

        _BaseTexture2["default"].addToCache(baseTexture, video._pixiId);
      }

      return baseTexture;
    }
  }, {
    key: "fromUrl",
    value: function fromUrl(videoSrc, scaleMode, crossorigin, autoPlay) {
      var video = document.createElement("video");
      video.setAttribute("webkit-playsinline", "");
      video.setAttribute("playsinline", "");
      var url = videoSrc.src || videoSrc;

      if (crossorigin === undefined && url.indexOf("data:") !== 0) {
        video.crossOrigin = (0, _determineCrossOrigin["default"])(url);
      } else if (crossorigin) {
        video.crossOrigin = typeof crossorigin === "string" ? crossorigin : "anonymous";
      }

      video.appendChild(createSource(url, videoSrc.mime));
      video.load();
      return VideoBaseTexture.fromVideo(video, scaleMode, autoPlay);
    }
  }]);

  return VideoBaseTexture;
}(_BaseTexture2["default"]);

exports["default"] = VideoBaseTexture;
VideoBaseTexture.fromUrls = VideoBaseTexture.fromUrl;

function createSource(path, type) {
  if (!type) {
    var purePath = path.split("?").shift().toLowerCase();
    type = "video/".concat(purePath.substr(purePath.lastIndexOf(".") + 1));
  }

  var source = document.createElement("source");
  source.src = path;
  source.type = type;
  return source;
}
//# sourceMappingURL=VideoBaseTexture.js.map