"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var TickerListener = /*#__PURE__*/function () {
  function TickerListener(fn) {
    var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
    var priority = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    var once = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

    _classCallCheck(this, TickerListener);

    this.fn = fn;
    this.context = context;
    this.priority = priority;
    this.once = once;
    this.next = null;
    this.previous = null;
    this._destroyed = false;
  }

  _createClass(TickerListener, [{
    key: "match",
    value: function match(fn, context) {
      context = context || null;
      return this.fn === fn && this.context === context;
    }
  }, {
    key: "emit",
    value: function emit(deltaTime) {
      if (this.fn) {
        if (this.context) {
          this.fn.call(this.context, deltaTime);
        } else {
          this.fn(deltaTime);
        }
      }

      var redirect = this.next;

      if (this.once) {
        this.destroy(true);
      }

      if (this._destroyed) {
        this.next = null;
      }

      return redirect;
    }
  }, {
    key: "connect",
    value: function connect(previous) {
      this.previous = previous;

      if (previous.next) {
        previous.next.previous = this;
      }

      this.next = previous.next;
      previous.next = this;
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var hard = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
      this._destroyed = true;
      this.fn = null;
      this.context = null; // Disconnect, hook up next and previous

      if (this.previous) {
        this.previous.next = this.next;
      }

      if (this.next) {
        this.next.previous = this.previous;
      } // Redirect to the next item


      var redirect = this.next; // Remove references

      this.next = hard ? null : redirect;
      this.previous = null;
      return redirect;
    }
  }]);

  return TickerListener;
}();

exports["default"] = TickerListener;
//# sourceMappingURL=TickerListener.js.map